/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview App module definition
 */

define(function(require) {
    'use strict';

    // List all scripts that need to be loaded before everything else. Suitable for browser polyfills, etc.
    require('polyfills/requestAnimationFrame');
    require('polyfills/function.bind');

    var $ = require('jquery');
    var Util = require('lib/Util');
    var RouteHandler = require('lib/RouteHandler');
    /**
     * Initial application setup. Runs once upon every page load.
     *
     * @name App
     * @class App Initial application setup. Runs once upon every page load.
     * @constructor
     */
    var App = function() {
    };


    /**
     * Initializes the application and kicks off loading of prerequisites
     */
    App.prototype.init = function () {

		var platform = device.platform.toLowerCase();
		var version = parseFloat(device.version);
		
		Util.log('Device Platform: ' + platform);
		Util.log('OS Version: ' + version);
		Util.log('App UUID: ' + SETTINGS.APP_UUID);


        this.routeHandler = new RouteHandler();
        this.Branding.init();
    };

    /**
     * Used to pull in facility settings and set them across the app
     */
    App.prototype.Branding = {
        BRAND_COLOR: SETTINGS.FACILITY_COLOR || '#666666',
        SELECTORS_AND_PROPS: [
            {
                selector: '.hdrMain',
                property: 'background-color'
            },
            {
                selector: 'body',
                property: 'background-color'
            },
            {
                selector: '.mix-hdg_primary',
                property: 'color'
            },
            {
                selector: '.gridIcon-img_frame > *',
                property: 'background-color'
            }
        ],

        IMAGE_PATH: 'assets/media/images/',
        BRAND_HEADER_FILENAME: 'header.png',

        cssText: '',

        /**
         * Initializes branding
         */
        init: function () {
            this.setImages();
            this.setColors();
            this.outputCSS();
        },

        /**
         * Sets the color css text
         */
        setColors: function () {
            var i = this.SELECTORS_AND_PROPS.length;
            var currentSelector;
            var currentProperty;

            while (i--) {
                currentSelector = this.SELECTORS_AND_PROPS[i].selector;
                currentProperty = this.SELECTORS_AND_PROPS[i].property;

                this.cssText = this.cssText + '\n' + currentSelector + ' { ' + currentProperty + ': ' + this.BRAND_COLOR + '; } ';
            }
        },

        /**
         * Sets the header image
         */
        setImages: function () {
            // var $splashImg = $('js-logo-image');
            var $headerImg = $('#js-logo-image');
            var combinedPath = this.IMAGE_PATH + this.BRAND_HEADER_FILENAME;
            this.cssText = this.cssText + '.headerLogo' + ' { background-image: url("' + combinedPath + '"); } ';
        },

        /**
         * Outputs the css to the document
         */
        outputCSS: function () {
            var style = document.createElement('style');
            style.type = 'text/css';

            if (style.styleSheet){
                style.styleSheet.cssText = this.cssText;
            } else {
                style.appendChild(document.createTextNode(this.cssText));
            }

            document.head.appendChild(style);
        }
    };

    return App;
});
