/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview APIHandler module definition
 */

define(function(require) {
    'use strict';

    var $ = require('jquery');
    var Util = require('lib/Util');
    var Views = require('lib/Views');

    var APIHandler = function() {
        this.apiUrl = SETTINGS.API_URL;
        this.facilityId = SETTINGS.FACILITY_ID;
		this.appUUID = Util.appUUID();

        this.viewMethodMap = {};
        this.viewMethodMap[Views.MainMenu] = 'get_buttons';
        this.viewMethodMap[Views.Notifications] = 'get_notifications';
        this.viewMethodMap[Views.NotificationsDetail] = 'get_notifications';
        this.viewMethodMap[Views.UpcomingEvents] = 'get_upc_events';
        this.viewMethodMap[Views.UpcomingEventsDetail] = 'get_upc_events';
        this.viewMethodMap[Views.Weblist] = 'get_web_list';
        this.viewMethodMap[Views.Listing] = 'get_announcements';
        this.viewMethodMap[Views.Announcements] = 'get_announcements';
        this.viewMethodMap[Views.Generic] = 'get_buttons';
        this.viewMethodMap[Views.Leagues] = 'get_leagues';
        this.viewMethodMap[Views.LeagueGames] = 'get_games';
        this.viewMethodMap[Views.LeagueGameDetail] = 'get_games';
        this.viewMethodMap[Views.Schedule] = 'get_schedule';
        this.viewMethodMap[Views.Webpage] = null;
        this.viewMethodMap[Views.Newsfeed] = 'get_feed';
        this.viewMethodMap[Views.NewsfeedDetail] = 'get_feed';
        this.viewMethodMap[Views.Detail] = 'get_event';
        this.viewMethodMap[Views.BasicInfo] = 'get_announcements';
        this.viewMethodMap[Views.Settings] = null;
        this.viewMethodMap[Views.About] = 'get_about';
        this.viewMethodMap[Views.ToggleNotifications] = null;
        this.viewMethodMap[Views.Feedback] = null;
        this.viewMethodMap[Views.SubMenuPartial] = 'get_buttons';
        this.viewMethodMap[Views.OptionsPartial] = null;
        this.viewMethodMap[Views.SetPreferredLocation] = 'get_locations';

        this.init();
    };

    /**
     * Initializes the object, calls setupHandlers
     *
     * returns {APIHandler}
     */
    APIHandler.prototype.init = function() {
        this.setupHandlers();

        return this;
    };

    /**
     * Binds the scope of any handler functions
     * Should only be run on initialization of the view
     *
     * returns {APIHandler}
     */
    APIHandler.prototype.setupHandlers = function() {
        return this;
    };


    /**
     * Helper function to run the ajax call to the api
     * @param {function} callback The function to run after the ajax call
     * @param {object} data The data to be passed to the ajax call
     *
     * returns {APIHandler}
     */
    APIHandler.prototype.getJsonHelper = function (callback, data) {
        var retry = function() {
            //just keep alerting, until we get an internet connection
            this.getJsonHelper(callback, data);
        }.bind(this);

        //check if we have internet connection
        if (navigator.connection != null &&
            navigator.connection.type == Connection.NONE) {
            Util.log('Application requires an internet connection');
            navigator.notification.alert(
                'Application requires an internet connection',
                retry,
                'Error',
                'Retry'
            );
            return this;
        }

        //we have internet connection, so go grab the data
        this.getJsonCallback = callback;
        var jqxhr = $.ajax({
                url: this.apiUrl,
                data: data,
                type: 'GET'
            })
            .done(this.onGetJsonHelperDone.bind(this))
            .fail(function() {
                Util.log('Could not reach API');
                navigator.notification.alert(
                    'No Internet Connection Available',
                    retry,
                    'Error',
                    'Retry'
                );
            });

        return this;
    };

    /**
     * Parses the data returned from ajax call
     * @param {object} data The data returned from the ajax call
     */
    APIHandler.prototype.parseJsonCallback = function(data) {
        var jsonParsed = Util.parseAjaxJson(data);

        if (this.getViewDataCallback == null) {
            return;
        }

        this.getViewDataCallback(jsonParsed);
    };

    /**
     * Gets the view data after an ApiHandler object has been initialized
     * @param {function} data The data returned from the ajax call
     * @param {string} view The view to get the data for
     * @param {object} args Any additional args to be passed to the ajax call
     */
    APIHandler.prototype.getViewData = function(callback, view, args) {
	    Util.log('APIHandler.getViewData');
        this.getViewDataCallback = callback;

        if (this.viewMethodMap[view] == null) {
        	Util.log('no data to be had!');
            // Return an empty data object to be used in the handlebars template
            return this.getViewDataCallback({});
        }

        var method = this.viewMethodMap[view];
        var data = {
            method: method,
            p: this.facilityId,
            gi:SETTINGS.GI,
			uuid: this.appUUID
        };
        $.extend(data, args);
        
        Util.log('data', data);

        this.getJsonHelper(
            this.parseJsonCallback.bind(this),
            data
        );

        return this;
    };

    /**
     * Callback function for when the ajax call is successful
     */
    APIHandler.prototype.onGetJsonHelperDone = function (data) {
        if (this.getJsonCallback == null) {
            return;
        }

        this.getJsonCallback(data);
    };

    return APIHandler;
});
