/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/*
 * Authorization is used for validating users if necessary
*/
define(function (require) {
    'use strict';

    var $ = require('jquery');
    var APIHandler = require('lib/APIHandler');
    var Util = require('lib/Util');

    var AuthorizationHandler = function($button) {
        this.protected = $button.data('protected') === 1;
        this.b = $button.data('id');
        this.method = 'verify_password';
        this.dfd = $.Deferred();
    };

    var proto = AuthorizationHandler.prototype;

    /**
   * Called to handle when pages are password-protected or if the user entered an incorrect password.
   * The promise object is not resolved until the user either gets the password correct or cancels.
   *
   * $button: the DOM button that was clicked, which holds info we'll need in data- attributes
   * incorrect (optional): used internally, when the user has entered an incorrect password.
                           Indicates that we need to try again.

   * returns {Jquery Promise}
   */
    proto.validateUser = function (incorrect) {
        if (this.protected) {
            var message = incorrect ? 'Your password was incorrect. Please try again.' : 'Password Required';
            var callback = function(results) {
                var pw = results.input1;
                var cancelled = results.buttonIndex == 2; // pw == null;
                if (!cancelled) {
                    //check if the password is correct
                    var apiHandler = new APIHandler();
                    var requestData = { method: this.method, b: this.b, pw: pw };
                    apiHandler.getJsonHelper(this.validationCompleteHandler(), requestData);
                } else {
                    //the user cancelled, so do nothing
                    this.dfd.reject();
                }
            }.bind(this);
            var title = 'Enter Password';

            navigator.notification.prompt(message, callback, title);
        } else {
            //not protected, so valid
            this.dfd.resolve();
        }
        return this.dfd.promise();
    };

    /*
    * Simply resolves or rejects the promise, based on the response from 'verify_password'
    */
    proto.validationCompleteHandler = function() {
        return function (data) {
            data = Util.parseAjaxJson(data);
            var success = parseInt(data.error.code) === 0;
            if (success) {
                //valid password, so let them through
                this.dfd.resolve();
            } else {
                //re-prompt, letting user know the password was incorrect
                //note that the method will use the same deferred object, so we can
                //continue calling this method recursively if the user is bad with passwords
                this.validateUser(true);
            }
        }.bind(this);
    }

    return AuthorizationHandler;
});
