/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * Used to handle date formatting
 * @fileOverview Date module definition
 */

define(function(require) {
    'use strict';

    var DateHandler = {
        DaysAbbreviated: [
            'Sun',
            'Mon',
            'Tue',
            'Wed',
            'Thu',
            'Fri',
            'Sat'
        ],
        Days: [
            'Sunday',
            'Monday',
            'Tuesday',
            'Wednesday',
            'Thursday',
            'Friday',
            'Saturday'
        ],
        MonthsAbbreviated: [
            'Jan',
            'Feb',
            'Mar',
            'Apr',
            'May',
            'Jun',
            'Jul',
            'Aug',
            'Sep',
            'Oct',
            'Nov',
            'Dec'
        ],
        Months: [
            'January',
            'February',
            'March',
            'April',
            'May',
            'June',
            'July',
            'August',
            'September',
            'October',
            'November',
            'December'
        ],
		/**
			* Formats a date string given a desired format.
         	* @param {string} dateString The string of the desired date to format
         	* @param {string} format The format string
         	* @returns {string}
        */
		formatTimestamp: function(timestamp, format) {
			try {
				if (timestamp == null) {
					console.log('Error: timestamp is null');
					return;
				}
			
				var dateObject = null,
					formattedString = null;
			
				var dateObject = new Date(parseInt(timestamp) * 1000);

				var time = this.getTimeString(dateObject);

				switch (format) {
					case 'dateObject':
						formattedString = dateObject.toString();
						break;

					case 'full':
						formattedString = this.Days[dateObject.getDay()] + ', ' +
							this.Months[dateObject.getMonth()] +
							' ' + dateObject.getDate() + ', ' +
							dateObject.getFullYear();
						break;

					case 'fullAbbreviated':
						formattedString = this.DaysAbbreviated[dateObject.getDay()] +
							', ' +
							this.MonthsAbbreviated[dateObject.getMonth()] +
							' ' + dateObject.getDate() + ', ' +
							dateObject.getFullYear();
						break;

					case 'leftHeader':
						formattedString = this.DaysAbbreviated[dateObject.getDay()];
						break;

					case 'rightHeader':
						formattedString = this.Months[dateObject.getMonth()] +
							' ' + dateObject.getDate() + ', ' +
							dateObject.getFullYear();
						break;

					case 'date':
						formattedString = dateObject.getFullYear() +
							'/' + dateObject.getMonth() + '/' +
							dateObject.getDate();
						break;

					case 'longdate':
						formattedString = this.Days[dateObject.getDay()] + ', ' +
							this.Months[dateObject.getMonth()] +
							' ' + dateObject.getDate() + ', ' +
							dateObject.getFullYear();
						break;

					case 'dateSortableKey':
						var monthKey = dateObject.getMonth();
						var dayKey = dateObject.getDate();

						if (monthKey < 10) {
							monthKey = '0' + monthKey;
						}
						if (dayKey < 10) {
							dayKey = '0' + dayKey;
						}

						formattedString = dateObject.getFullYear() +
							monthKey +
							dayKey;
						break;

					case 'time':
						formattedString = time;
						break;

					case 'datetime':
						formattedString = this.Days[dateObject.getDay()] + ', ' +
							this.Months[dateObject.getMonth()] +
							' ' + dateObject.getDate() + ', ' +
							dateObject.getFullYear() +
							' | ' + time;
						break;

					default:
						formattedString = dateString;
						break;
				}
				return formattedString;
			} catch(e) {
			}
		},
		
        /**
         * Maintained for backward compatibility, use formatTimestamp when possible
         * @param {string} dateString The string of the desired date to format
         * @param {string} format The format string
         * @returns {string}
         */
        format: function(dateString, format, augmentTime) {
            if (dateString == null) {
                console.log('Error: dateString is null');
                return;
            }

            dateString = dateString.replace(' ', 'T');
            var dateObject = new Date(String(dateString));

			var timestamp = null;
			if(typeof augmentTime === 'undefined') {
				timestamp = dateObject.getTime() / 1000 +
	                (dateObject.getTimezoneOffset() * 60);
	        } else {
	        	timestamp = dateObject.getTime() / 1000;
	        }
			
            return this.formatTimestamp(timestamp, format);
        },
        /**
         * Returns a time string given a date object
         * @param {Date} dateObject The date object to return a time for
         * @returns {string}
         */
        getTimeString: function(dateObject) {
            var timeString = '';
            var meridiem = '';

            var hours = parseInt(dateObject.toString().substr(16, 2), 10);
            var minutes = parseInt(dateObject.toString().substr(19, 2), 10);

            if (hours < 12) {
                meridiem = 'AM';
            }
            else {
                meridiem = 'PM';
            }

            hours = hours % 12;
            if (hours == 0) {
                hours = 12;
            }
            // Put back in to add a 0 in front of the hours
            // if (hours < 10) {
            //     hours = '0' + hours;
            // }

            if (minutes < 10) {
                minutes = '0' + minutes;
            }

            timeString = hours + ':' + minutes + ' ' + meridiem;

            return timeString;
        }
    };

    return DateHandler;
});
