/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * This handler controls the application first run
 * @fileOverview FirstRunHandler module definition
 */

define(function(require) {
    'use strict';

    var $ = require('jquery');
    var NotificationTags = require('lib/NotificationTags');
    var Util = require('lib/Util');

    /**
     * A handler to control the applications first run.
     *
     * @name FirstRunHandler
     * @class FirstRunHandler A handler to control the applications first run.
     * @constructor
     */
    var FirstRunHandler = function () {
        this.appHasRunBeforeKey = 'appHasRunBefore';
        this.isPushEnabled = 1;
        this.$window = $(window);

        this.appHasRunBefore = window.localStorage.getItem(
            this.appHasRunBeforeKey
        );
        if (this.appHasRunBefore == null || this.appHasRunBefore == 0) {
            this.appHasRunBefore = 0;
            window.localStorage.setItem(
                this.appHasRunBeforeKey,
                this.appHasRunBefore
            );
        }

        // Util.log('appHasRunBefore: ' + this.appHasRunBefore);

        this.init();
    };

    /**
     * Initializes the First Run Handler
     * Sets the flag and sets notification tags if needbe
     *
     * returns {FirstRunHandler}
     */
    FirstRunHandler.prototype.init = function() {
        this.setupHandlers()
            .performFirstRun();

        return this;
    };

    /**
     * Binds the scope of any handler functions
     * Should only be run on initialization of the view
     *
     * returns {FirstRunHandler}
     */
    FirstRunHandler.prototype.setupHandlers = function() {
        this.onPerformNotificationCheckCallbackHandler =
            this.onPerformNotificationCheckCallback.bind(this);
        return this;
    };

    /**
     * Performs the first run sweep of the application
     *
     * returns {FirstRunHandler}
     */
    FirstRunHandler.prototype.performFirstRun = function() {
        if (this.appHasRunBefore) {
            //Run resume handler on startup, so if we have any notifications and the app was not running, we still get sent to the notification page
            NotificationTags.onResume();
            return this;
        }

        if (device.platform.toLowerCase() != 'ios') {
        	Util.log('platform is Android');
            this.performNotificationCheck();
        }
        else {
        	Util.log('platform is iOS');
            this.isPushEnabled = 1;
            this.configureNotifications();
        }

        return this;
    };

    FirstRunHandler.prototype.configureNotifications = function () {
    	Util.log('configureNotifications');
        NotificationTags.setIsPushEnabled(this.isPushEnabled);
        NotificationTags.setNotificationTags().then(function () {
            if (this.firstRunCallback != null) {
                this.firstRunCallback();
            }

            this.performFirstRunEnd();
        }.bind(this));
    };

    /**
     * Performs the push notifications check
     *
     * returns {FirstRunHandler}
     */
    FirstRunHandler.prototype.performNotificationCheck = function () {
        navigator.notification.confirm(
            'Notifications may include alerts, sounds and icon badges. These can be configured in Settings at any time.',
            this.onPerformNotificationCheckCallbackHandler,
            'We Would Like to Send You Push Notifications!',
            ['Don\'t Allow', 'OK']
        );

        return this;
    };

    ///**
    // * Event handler for when the push notification check finishes
    // * @param {number} buttonIndex The index of the button pushed (starts at 1)
    // */
    FirstRunHandler.prototype.onPerformNotificationCheckCallback = function (buttonIndex) {
        this.isPushEnabled = buttonIndex === 2 || buttonIndex === true ? 1 : 0; //browser returns boolean, phonegap returns non-zero-based index...
        this.configureNotifications();
    };

    /**
     * Runs after the first run has finished, displays the options partial
     */
    FirstRunHandler.prototype.performFirstRunEnd = function() {
        window.localStorage.setItem(this.appHasRunBeforeKey, 1);
    };

    return FirstRunHandler;
});
