/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * This handler controls the application routing
 * @fileOverview RouteHandler module definition
 */

define(function(require) {
    'use strict';

    var $ = require('jquery');

    var Util = require('lib/Util');
    var appLauncher = require('lib/appLauncher');
    var Views = require('lib/Views');
    //var FirstRunHandler = require('lib/FirstRunHandler');
    var Handlebars = require('handlebars');
    require('handlebars-templates');
    var DataHandler = require('lib/DataHandler');
    var MainMenuView = require('views/MainMenuView');
    var AuthorizationHandler = require('lib/AuthorizationHandler');

    var MOBILE_PAGE_SELECTOR = '.js-jquery-mobile-page';
    var MOBILE_PAGE_ACTIVE_SELECTOR = 'js-mobile-page-active';

    var SetPreferredLocationModel = require('view-models/SetPreferredLocationModel');

    /**
     * A handler to control application routing.
     *
     * @name RouteHandler
     * @class RouteHandler A handler to control application routing.
     * @constructor
     */
    var RouteHandler = function () {
        this.preferredLocationSet = SetPreferredLocationModel.prototype.preferredLocation.isSet();
        //if (this.preferredLocationSet) {
        //    this.runFirstRunHandler();
        //}

        this.$templateContainer = null;
        this.$window = null;
        this.$optionsPartial = null;

        this.isEnabled = false;
        this.lastPartialId = null;

        this.init();
    };

    //RouteHandler.prototype.runFirstRunHandler = function() {
    //    //this.firstRunHandler = new FirstRunHandler();
    //};

    /**
     * Initializes the Route Handler
     * Runs a single setupHandlers call, followed by createReferences and enable
     *
     * returns {RouteHandler}
     */
    RouteHandler.prototype.init = function() {
        this.setupHandlers()
            .createReferences()
            .enable()
            .initPageLoad();

        return this;
    };

    /**
     * Binds the scope of any handler functions
     * Should only be run on initialization of the view
     *
     * returns {RouteHandler}
     */
    RouteHandler.prototype.setupHandlers = function() {
        //this.onPageShownHandler = this.onPageShown.bind(this);
        this.onNerderyPageShownHandler = this.onNerderyPageShown.bind(this);
        this.onJqueryPageShownHandler = this.onJqueryPageShown.bind(this);
        this.onHashChangeHandler = this.onHashChange.bind(this);
        this.onRecieveDataHandler = this.onRecieveData.bind(this);
        this.onShowPartialTemplateHandler = this.onShowPartialTemplate.bind(this);
        this.onNavigationButtonClickHandler = this.onNavigationButtonClick.bind(this);
        this.onListingHashChangeHandler = this.onListingHashChange.bind(this);
        this.onHideSubMenuHandler = this.onHideSubMenu.bind(this);
        this.onButtonSelectTapHandler = this.onButtonSelectTap.bind(this);
        this.onpushNotificationReceivedHandler = this.onpushNotificationReceived.bind(this);
        this.onListSearchHandler = this.onListSearch.bind(this);
        this.onTemplateContainerFadeInHandler = this.onTemplateContainerFadeIn.bind(this);

        return this;
    };

    /**
     * Creates references to dom elements to be used by the object
     *
     * returns {RouteHandler}
     */
    RouteHandler.prototype.createReferences = function() {
        this.$headerContainer = $('#header-container');
        this.$jqueryMobilePages = $(MOBILE_PAGE_SELECTOR);
        this.$window = $(window);
        this.$optionsPartial = $('#options-partial');

        return this;
    };

    /**
     * Enables the component
     * Performs any event binding to handlers
     * Exits early if it is already enabled
     *
     * @returns {RouteHandler}
     */
    RouteHandler.prototype.enable = function() {
        if (this.isEnabled) {
            return this;
        }
        this.isEnabled = true;

        this.$window
            .on('hashchange', this.onHashChangeHandler);

        this.$window
            .on('showPartialTemplate', this.onShowPartialTemplateHandler);

        this.$window
            .on('onNavigationButtonClick', this.onNavigationButtonClickHandler);

        this.$window
            .on('onButtonSelectTap', this.onButtonSelectTapHandler);

        this.$window
            .on('onListingHashChange', this.onListingHashChangeHandler);

        this.$window
            .on('hideSubMenu', this.onHideSubMenuHandler);

        this.$window
            .on('nerderyPageshow', this.onNerderyPageShownHandler);

        this.$window
            .on('pushNotificationReceived', this.onpushNotificationReceivedHandler);

        this.$window
            .on('listSearch', this.onListSearchHandler);

        this.$jqueryMobilePages
            .on('pageshow', this.onJqueryPageShownHandler);

        return this;
    };

    /**
     * Runs on initial page load
     */
    RouteHandler.prototype.initPageLoad = function () {
        this.initialPage = (this.preferredLocationSet ? Views.MainMenu : Views.SetPreferredLocation);
        this.view = null;
        this.viewClass = null;
        this.viewClassObjects = {};
        var hash = this.initialPage;
        //this.performHashChange(hash); //doesn't change hash
        this.switchHash(hash);
    };

    /**
     * Loads a given route and calls the data handler
     * @param {string} hash The hashed route to be loaded
     *
     * @returns {RouteHandler}
     */
    RouteHandler.prototype.loadRoute = function(hash) {
        Util.log('------------------------- loadRoute');

        var route = hash.substr(1, hash.length - 1);
        Util.log('route: ' + route);

        var dataHandler = new DataHandler(route);
        Util.log('dataHandler instantiated, setting up data');

        dataHandler.setupData(
            this.onRecieveDataHandler
        );
        Util.log('data setup complete');

        return this;
    };

    /**
     * Enables the component
     * Performs any event binding to handlers
     * Exits early if it is already enabled
     *
     * @returns {RouteHandler}
     */
    RouteHandler.prototype.loadTemplate = function (view, templateName, templateContent) {
        Util.log('------------------------- loadTemplate');

        //close the keyboard
        $('input:focus, textarea:focus, select:focus').blur();

        this.view = view;
        // Setup variables
        this.$templateContainer = $('#' + view);

        $.extend(
            templateContent,
            {
                TEMPLATE_VIEW: view,
                IS_SCHEDULE: view === Views.Schedule
            }
        );
        // Load Handlebar template
        Handlebars.partials = Handlebars.templates;
        var compiledTemplate = Handlebars.templates[templateName];
        this.$templateContainer.empty();

        this.$templateContainer
            .html(compiledTemplate(templateContent));

        Util.log('templateView: ' + view);
        Util.log('templateContainer id: ' + this.$templateContainer.attr('id'));
        // Util.log('templateContainer: ' + this.$templateContainer.html());

        this.$templateContainer
            .trigger('nerderyPageshow');

        // if haven't set preferred location, hide back and menu button
        if (!this.preferredLocationSet) {
            $('.btn-main-menu, .btn_back').css('visibility', 'hidden');
        }

        // show current template
        this.showView(this.view);

        return this;
    };

    /**
     * Helper function to load a hash given a query object
     * @param {string} view The view to append to the hash symbol to load
     * @param {object} queryObject The query object to pass as the query param
     */
    RouteHandler.prototype.switchHash = function(view, queryObject) {
        Util.log('------------------------- switchHash');
        var hash = '#' + view;

        if (queryObject != null) {
            hash += '?' + $.param(queryObject);
        }

        location.hash = hash;
        Util.log('hash: ' + hash);
    };

    RouteHandler.prototype.onButtonSelectTap = function (event, $button) {
        var view = $button.data('feed-type');
        var locationId;
        if (view === Views.SetPreferredLocation) {
            locationId = $button.addClass('selected').data('locationid');
            SetPreferredLocationModel.prototype.preferredLocation.set(locationId);

            //Go to main-menu once user chooses a location
            this.preferredLocationSet = true;
            this.switchHash(Views.MainMenu);
        }
    };

    RouteHandler.prototype.onpushNotificationReceived = function (incoming) {
        this.switchHash(Views.Notifications);
    };

    RouteHandler.prototype.onListSearch = function (event) {
        //pass data back to listview via triggering event
        this.$window.trigger('listRefresh', [this.viewTemplateData]);
    };

    /**
     * Event handler for when a navigation button is clicked
     * @param {object} event The event object
     * @param {object} $button The jquery object of the dom element clicked
     */
    RouteHandler.prototype.onNavigationButtonClick = function (event, eventData) {
        Util.log('------------------------- onNavigationButtonClick');
        var $button = eventData.$button;
        var MainMenuView = eventData.MainMenuView;
        if ($button === undefined) {
            $button = eventData; //fallback for old code.
        }

        new AuthorizationHandler($button).validateUser().then(function () {
            var queryObject = null;
            var view = $button.data('feed-type');

            if(view === Views.ShowSubMenu) {
                MainMenuView.showSubMenu();
                return false;
            } else {
                this.hideView($button);
            }

            Util.log('view: ' + view);

            switch (view) {
                case Views.Announcements:
                case Views.Leagues:
                case Views.About:
                case Views.Notifications:
                case Views.Settings:
                    queryObject = {
                        'appButtonTitle': $button.data('title')
                    };
                    this.switchHash(view, queryObject);
                    break;

                case Views.Generic:
                case Views.Weblist:
                case Views.UpcomingEvents:
                    queryObject = {
                        'appButtonTitle': $button.data('title'),
                        'b': $button.data('id')
                    };
                    this.switchHash(view, queryObject);
                    break;

                case Views.NotificationsDetail:
                    queryObject = {
                        'ni': $button.data('ni')
                    };
                    this.switchHash(view, queryObject);
                    break;

                case Views.UpcomingEventsDetail:
                    queryObject = {
                        'b': $button.data('id'),
                        'ui': $button.data('ui')
                    };
                    this.switchHash(view, queryObject);
                    break;

                case Views.LeagueGames:
                    queryObject = {
                        'appButtonTitle': $button.data('title'),
                        'si': $button.data('si')
                    };
                    this.switchHash(view, queryObject);
                    break;

                case Views.LeagueGameDetail:
                    queryObject = {
                        'si': $button.data('si'),
                        'gi': $button.data('gi')
                    };
                    this.switchHash(view, queryObject);
                    break;

                case Views.Schedule:
                    queryObject = {
                        'appButtonTitle': $button.data('title'),
                        'r': $button.data('schedule-header-ids'),
						'b': $button.data('id')
                    };
                    this.switchHash(view, queryObject);
                    break;

                case Views.Detail:
                    queryObject = {
                        'sectionTitle': $button.data('section-title'),
                        'e': $button.data('eventid'),
                        't': $button.data('type')
                    };
                    this.switchHash(view, queryObject);
                    break;
                    
                case Views.ExternalApp:
                	Util.log(
                		JSON.stringify($button.data('external-app-name')) +
                		JSON.stringify($button.data('external-app-params'))
                	);
                	window.open(
                		'https://geo.itunes.apple.com/us/app/facebook/id28488215?mt=8',
                		'_system',
                		'location=no'
                	);
                	
                	break;

                case Views.Webpage:
                	var url = $button.data('url')
                		.replace('[[USER_UUID]]', Util.appUUID())
                    	.replace('[[FACILITY_ID]]', SETTINGS.FACILITY_ID);
                    
                    /* START DEBUG CODE */
					var dateObject = new Date(String("2015-11-02T16:30:00"));
					var time = dateObject.getTime();
                    var tzOffset = dateObject.getTimezoneOffset();
                    
                    dateObject = new Date(
						dateObject.getTime() +
						(tzOffset * 60 * 1000)
					);
                    var timeModified = dateObject.getTime();
                    	
                    if(url.indexOf("[[TZ_OFFSET]]") > -1) {
                    	url = url.replace("[[TZ_OFFSET]]", tzOffset);
                    }
                    
					if(url.indexOf("[[DEBUG_TIME]]") > -1) {
                    	url = url.replace("[[DEBUG_TIME]]", time);
                    }
                    
					if(url.indexOf("[[DEBUG_TIME_MODIFIED]]") > -1) {
                    	url = url.replace("[[DEBUG_TIME_MODIFIED]]", timeModified);
                    }
                    /* END DEBUG CODE */

                    Util.windowOpen(
                    	url,
                    	'_blank',
                    	'location=no,EnableViewPortScale=yes'
                    );
                    break;

                case Views.Newsfeed:
                    queryObject = {
                        'appButtonTitle': $button.data('title'),
                        'b': $button.data('id')
                    };
                    this.switchHash(view, queryObject);
                    break;

                case Views.NewsfeedDetail:
                    queryObject = {
                        'b': $button.data('id'),
                        'ai': $button.data('article-id')
                    };
                    this.switchHash(view, queryObject);
                    break;
            }
        }.bind(this));
    };


    /**
     * Event handler for when a partial is shown
     * @param {object} event The event object
     * @param {function} callback The function to set as the receive data callback
     * @param {string} view View to display
     * @param {object} queryObject
     */
    RouteHandler.prototype.onShowPartialTemplate = function(event, callback, view, queryObject) {
        Util.log('------------------------- onShowPartialTemplate');
        var route = view;
        if (queryObject != null) {
            route += '?' + $.param(queryObject);
        }

        Util.log('route: ' + route);

        var dataHandler = new DataHandler(route);
        this.onRecieveDataCallback = callback;

        dataHandler.setupData(
            this.onRecieveDataHandler
        );

        if (queryObject != null && queryObject['b'] != null) {
            this.lastPartialId = queryObject['b'];
        }
    };

    /**
     * Event handler for the data handler has recieved data
     * @param {string} view The view to load
     * @param {string} template The template name
     * @param {object} viewClass The class to load as the view class
     * @param {object} viewData The data to be loaded in the view
     */
    RouteHandler.prototype.onRecieveData = function(view, template, viewClass, viewData) {
        this.viewClass = viewClass;
        this.viewTemplateData = {
            viewData: viewData,
            view: view
        };

        // Load handlebar template with template data
        this.loadTemplate(
            view,
            template,
            viewData
        );
    };

    RouteHandler.prototype.onJqueryPageShown = function(event) { // (event, ui)
        Util.log('------------------------- onJqueryPageShown');
        this.onPageShown(event, true);
    };

    RouteHandler.prototype.onNerderyPageShown = function(event) { // (event, ui)
        Util.log('------------------------- onNerderyPageShown');
        this.onPageShown(event, false);
    };

    /**
     * Event handler for when the page has finished loading
     */
    RouteHandler.prototype.onPageShown = function (event, isJQuery) {
        Util.log('------------------------- onPageShown');
        Util.log('view: ' + this.view);
        Util.log('----- START viewClassObjects');
        for (var prop in this.viewClassObjects) {
            if (this.viewClassObjects.hasOwnProperty(prop)) {
                Util.log('viewClassObjects: ' + prop);
            }
        }
        Util.log('----- END viewClassObjects');

        // Assign the view class handler to the template
        Util.log('current view class: ' + this.viewClass);
        if (this.viewClass != null) {
            if (isJQuery && this.isPopUp(this.view)) {
                Util.log('isJQUERY');
                Util.log('destroying view class in onPageShown: ' + this.view);
                this.viewClassObjects[this.view].destroy();
                Util.log('destroying view class in onPageShown: main-menu');
                this.viewClassObjects['main-menu'].destroy();
                this.viewClassObjects = {};

                this.view = 'main-menu';
                this.viewClass = MainMenuView;
                this.$templateContainer = $('#main-menu');
            }
            else if (this.viewClassObjects[this.view] != null) {
                // Destroy view class if it is already created
                this.viewClassObjects[this.view].destroy();
                Util.log(this.view + ' has been destroyed');
            }

            // Init view class
            var newViewClass = new this.viewClass(
                this.$templateContainer
            );

            // Store which view classes are initialized
            this.viewClassObjects[this.view] = newViewClass;
            Util.log('initialized view class: ' + this.view);
        }

        if (this.onRecieveDataCallback != null) {
            Util.log('running callback');
            this.onRecieveDataCallback();
            this.onRecieveDataCallback = null;
        }

        if (this.viewClass != null && this.viewClassObjects['main-menu'] !== undefined && this.lastPartialId) {
            Util.log('Initializing submenu');
            // Wait till this class is finished then fire.
            this.viewClassObjects['main-menu'].showSubMenuById(this.lastPartialId);
        }
    };

    RouteHandler.prototype.isPopUp = function (view) {
        view = view || this.view; //we will often simply use this.view, so make that the fallback
        return view === Views.SubMenuPartial || view === Views.OptionsPartial;
    };

    RouteHandler.prototype.hideView = function ($button) {
        var opensWindow = $button && $button.data('url');

        if (!opensWindow) {
            //only fade 'er out if it exists and if it's not already animating
            this.getShowing().fadeTo(150, 0, function () {
                $(this).removeClass(MOBILE_PAGE_ACTIVE_SELECTOR);
                $('#loadingPage').show();
            });
        }
    };

    RouteHandler.prototype.showView = function (view) {
        //only show, if not a submenu or list refresh to avoid flicker
        if (!this.isPopUp(view) && !this.isListRefresh) {
            //if we get back before the previous view is done fading out, shut it off and get it outta here.
            this.getShowing().removeClass(MOBILE_PAGE_ACTIVE_SELECTOR).stop().css('opacity', '0');

            //now bring it back. Fade it in, reeeeeaaaal smooooth, baby
            this.$templateContainer.fadeTo(150, 100, this.onTemplateContainerFadeInHandler);
        }
        this.isListRefresh = false; //reset this for next time.
    };


    /**
     * This function is only called by RouteHandler.prototype.showView. It used to be an anonymous function,
     * but it is called for almost every action, so I am making it a prototype method to hopefully speed things up.
     */
    RouteHandler.prototype.onTemplateContainerFadeIn = function () {
        var $templateContainer = this.$templateContainer;
        var $activePage = this.$templateContainer;

        if ($templateContainer.closest('[data-role="page"]')[0] !== $templateContainer[0]) {
            //I believe this was the cause of the back button issue.. logging just in case the error resurfaces.
            //The addClass(MOBILE_PAGE_ACTIVE_SELECTOR) below was adding to the submenu instead of the page.
            Util.log('this.$templateContainer is not the page');
            Util.log($templateContainer);
            if (console.trace) {
                console.trace();
            }
            //set the active page to the correct element so it will become visible when
            // the MOBILE PAGE ACTIVE class is added
            $activePage = this.$templateContainer.closest('[data-role="page"]');
        }

        $activePage.addClass(MOBILE_PAGE_ACTIVE_SELECTOR);

        Util.log('hiding loading page');
        $('#loadingPage').hide();

        //refresh list views, to fix issue of not being able to scroll to bottom
        if (this.viewClassObjects[this.view] && this.viewClassObjects[this.view].scrollView) {
            Util.log('Refreshing list');
            this.viewClassObjects[this.view].scrollView.refresh();
        } else {
            Util.log('did not refresh list'); //This usually fires when the 'back button bug' is occurring.
        }
    };

    RouteHandler.prototype.getShowing = function() {
        return $('.' + MOBILE_PAGE_ACTIVE_SELECTOR, this.$element);
    };

    /**
     * Event handler for when a listing hash change occurs
     */
    RouteHandler.prototype.onListingHashChange = function () {
        this.isListRefresh = true;
        this.performHashChange(window.location.hash);
    };

    /**
     * Event handler when a hash change occurs
     * @param {object} event The event object
     */
    RouteHandler.prototype.onHashChange = function (event) {
        this.hideView();
        this.performHashChange(window.location.hash);
    };

    /**
     * Helper function to take in a hash, destroy class objects and load the route
     * @param {string} hash The hash to pass to the loadRoute function
     */
    RouteHandler.prototype.performHashChange = function(hash) {
        var prop;

        Util.log('------------------------- performHashChange');
        Util.log('hash: ' + hash);

        this.view = null;
        this.viewClass = null;

        // Destroy all view classes
        for(prop in this.viewClassObjects) {
            if (this.viewClassObjects.hasOwnProperty(prop)) {
                Util.log('destroying view class in performHashChange: ' + prop);
                this.viewClassObjects[prop].destroy();
            }
        }
        this.viewClassObjects = {};

        if (hash == null || !hash) {
            hash = '#main-menu';
        }

        this.loadRoute(hash);
        
        Util.log('hash change complete');
    };

    RouteHandler.prototype.onHideSubMenu = function(event) {
        this.lastPartialId = null;
    };

    return RouteHandler;
});
