/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/* global define */
define(function(require) {
    'use strict';

    // libs
    var Util = require('lib/Util');
    var CalendarPlugin = require('calendar-plugin');
    var moment = require('moment');

    // vars
    var options = CalendarPlugin.getCalendarOptions();
    var format = 'M/D h:mm a';
    var hours = 'h:mm a';
    var lineBreak = '\r\n';
    var through = ' - ';

    var onError = function(error) {
        navigator.notification.alert(
            'Could not add event to calendar',
            function() {},
            'Error',
            'Close'
        );
        Util.log('Error occurred - ' + error);
    };

    /**
    * addEvent
    * uses a the Calendar Plugin to save an event with an optional reminder to
    * the user's calendar. Set minutes to null for no reminder.
    *
    * @param {Object} details an object containing details about the event
    * @param {Number} minutes number of minutes to set the reminder to
    */
    return function addCalendarEvent(details, minutes, successCallback) {

        var onSuccess;
        var diff;

        // use moment to wrap the times for crossbrowser compatibility
        var start = moment(details.start);
        var end = moment(details.end);

        // make diff string
        if (start.diff(end, 'days') === 0) {
            diff = start.format(format) + through + end.format(hours);
        } else {
            diff = start.format(format) + through + end.format(format);
        }

        // store minutes in options object
        options.firstReminderMinutes = minutes;

        // I'd like to abstract this callback out of this function somehow
        onSuccess = function(successMessage) {
            var message =
            details.title + lineBreak +
            diff + lineBreak +
            details.location
            ;

            navigator.notification.alert(
                message,
                function() {},
                'Event Added to Calendar',
                'Close'
            );

            if (typeof successCallback === 'function') {
                successCallback();
            }
        };

        CalendarPlugin.createEventWithOptions(
            details.title,
            details.location,
            details.notes,
            start.toDate(),
            end.toDate(),
            options,
            onSuccess,
            onError
        );
    };
});
