/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

define(function(require) {
    'use strict';

    var $ = require('jquery');
    //require('jquery-mobile');
    require('jquery-tap');

    /**
     * Mobile test regex to check and see if the user agent is a mobile
     * Checks for iOS, Android, Blackberry, and Windows Mobile
     *
     * @see http://stackoverflow.com/questions/8068052/phonegap-detect-if-running-on-desktop-browser
     * @type {REGEX}
     * @final
     * @static
     * @private
     */
    var MOBILE_TEST_REGEX = /(iPhone|iPod|iPad|Android|BlackBerry|IEMobile)/;

    /**
     * Feature Adapter to gather information about the current browser
     * Built to operate as a singleton
     * Subject to spoofing
     *
     * @class FeatureAdapter
     * @constructor
     */
    var FeatureAdapter = function() {
        this.init();
    };

    /**
     * Initialization which tests all possible features and sets the adapter's state
     *
     * @method init
     */
    FeatureAdapter.prototype.init = function() {
        /**
         * Flag for whether the current browser is a mobile one
         *
         * @property isMobile
         * @type {boolean}
         * @default false
         */
        this.isMobile = false;

        /**
         * Current tap state based on the mobile status
         * Should be considered a constant after the FeatureAdapter has executed
         * Event name for any click/tap-like events
         * Using a modified tap from the jquery.tap tool
         * If jQuery Mobile is used, it will cause a weird issue
         *
         * @property TAP
         * @type {string}
         * @default 'click'
         * @final
         */
        this.CLICK = 'click';
        this.TAP = 'gtap';
        this.TAP_START = 'mousedown';
        this.TAP_END = 'mouseup';
        this.TAP_LEAVE = 'mouseleave';
        this.TAP_MOVE = 'mousemove';
        this.TAP_CANCEL = null;

        this._testAllFeatures();
    };

    /**
     * Tests all features supported by the adapter
     * Any additional tests should be applied to this section
     *
     * @protected
     * @method _testAllFeatures
     */
    FeatureAdapter.prototype._testAllFeatures = function() {
        this._testMobile();
    };

    /**
     * Tests whether the current navigator's user agent is mobile
     *
     * @see http://stackoverflow.com/questions/8068052/phonegap-detect-if-running-on-desktop-browser
     * @protected
     * @method _testMobile
     */
    FeatureAdapter.prototype._testMobile = function() {
        this.isMobile = navigator.userAgent.match(MOBILE_TEST_REGEX);

        if (this.isMobile) {
            this.TAP = 'gtap';
            this.TAP_START = 'touchstart';
            this.TAP_END = 'touchend';
            this.TAP_LEAVE = 'touchleave';
            this.TAP_CANCEL = 'touchcancel';
            this.TAP_MOVE = 'touchmove';
        }
    };

    return new FeatureAdapter();

});
