/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview AnnouncementsViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var DateHandler = require('lib/DateHandler');
    var $ = require('jquery');
    //require('jquery-ui');

    var BaseViewModel = require('view-models/BaseViewModel');

    /**
     * A handler to load data to a view template.
     *
     * @name AnnouncementsViewModel
     * @class AnnouncementsViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var AnnouncementsViewModel = function(data, routeArgs) {
        if (data === null &&
            routeArgs === null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };


    /**
     * Added to make this class extend BaseViewModel
     */
    AnnouncementsViewModel.prototype = new BaseViewModel();
    AnnouncementsViewModel.prototype.constructor = AnnouncementsViewModel;


    /**
     * Parses the data for the given view
     *
     * returns {AnnouncementsViewModel}
     */
    AnnouncementsViewModel.prototype.parseData = function() {
        // BaseViewModel.prototype.parseData.call(this);
        this.viewModel = {};

        this.viewModel = {
            'section': []
        };

        var incomingData = this.data.announcements;
        var newRow = null;
        var prop = null;
        var date = null;
        var section = null;
        var sectionLength = null;
        var rows = null;

        section = {
            'header': [],
            'rows': []
        };
        sectionLength = this.viewModel.section.push(section);
        for (prop in incomingData) {
            incomingData[prop].datetime = DateHandler.format(
                incomingData[prop].date,
                'longdate'
            );
            rows = this.viewModel.section[sectionLength - 1].rows;
            newRow = {
                'announcement': incomingData[prop]
            };
            rows.push(newRow);
        }

        this.viewModel.title = this.routeArgs.appButtonTitle || 'Announcements';

        return this;
    };


    return AnnouncementsViewModel;
});
