/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview BaseViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var $ = require('jquery');
    //require('jquery-ui');

    /**
     * A handler to load data to a view template.
     *
     * @name BaseViewModel
     * @class BaseViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var BaseViewModel = function(data, routeArgs) {
        if (data == null &&
            routeArgs == null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };

    /**
     * Initializes the UI Component View
     * Runs a single parseData call
     *
     * returns {BaseViewModel}
     */
    BaseViewModel.prototype.init = function() {
        this.parseData();

        return this;
    };

    /**
     * Switchboards the given view to its specialized parse data function
     *
     * returns {jquery promise}
     */
    BaseViewModel.prototype.parseData = function () {
        this.viewModel = {};
        
        this.viewModel = this.data;
        
        return this;
    };

    /**
     * Returns the created viewModel object
     *
     * returns {jquery promise} (this way, we can override this method to do async manipulations before finally binding the view template with data)
     */
    BaseViewModel.prototype.getData = function () {
        var dfd = $.Deferred();
        dfd.resolve();
        return dfd.promise();
    };

    return BaseViewModel;
});
