/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview DetailViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var DateHandler = require('lib/DateHandler');
    var $ = require('jquery');
    //require('jquery-ui');

    var BaseViewModel = require('view-models/BaseViewModel');

    /**
     * A handler to load data to a view template.
     *
     * @name DetailViewModel
     * @class DetailViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var DetailViewModel = function(data, routeArgs) {
        if (data === null &&
            routeArgs === null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };


    /**
     * Added to make this class extend BaseViewModel
     */
    DetailViewModel.prototype = new BaseViewModel();
    DetailViewModel.prototype.constructor = DetailViewModel;


    /**
     * Parses the data for the given view
     *
     * returns {DetailViewModel}
     */
    DetailViewModel.prototype.parseData = function() {
        // BaseViewModel.prototype.parseData.call(this);
        this.viewModel = {};

        var incomingData = this.data.events;

        var items = [];
        var prop = null;
        var dateObject = null;
        var start = null;
        var end = null;

        for (prop in incomingData) {
            dateObject = DateHandler.formatTimestamp(incomingData[prop].start_timestamp, 'dateObject');
            incomingData[prop].dateObject = dateObject;

            start = {
                'date': DateHandler.formatTimestamp(incomingData[prop].start_timestamp, 'full'),
                'time': DateHandler.formatTimestamp(incomingData[prop].start_timestamp, 'time')
            };
            incomingData[prop].start = start;

            if (incomingData[prop].start_timestamp != incomingData[prop].end_timestamp) {
                end = {
                    'date': DateHandler.formatTimestamp(incomingData[prop].end_timestamp, 'full'),
                    'time': DateHandler.formatTimestamp(incomingData[prop].end_timestamp, 'time')
                };
                incomingData[prop].end = end;
            }

            items.push(incomingData[prop]);
        }

        var data = items[0];

        this.viewModel.headerFixed = true;
        this.viewModel.detail = data;
        // this.viewModel.title = data.information;
        this.viewModel.title = this.routeArgs.sectionTitle || data.information;

        return this;
    };


    return DetailViewModel;
});
