/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview GenericViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var Linkify = require('Linkify');
    var $ = require('jquery');
    //require('jquery-ui');

    var BaseViewModel = require('view-models/BaseViewModel');

    /**
     * A handler to load data to a view template.
     *
     * @name GenericViewModel
     * @class GenericViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var GenericViewModel = function(data, routeArgs) {
        if (data === null &&
            routeArgs === null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };


    /**
     * Added to make this class extend BaseViewModel
     */
    GenericViewModel.prototype = new BaseViewModel();
    GenericViewModel.prototype.constructor = GenericViewModel;


    /**
     * Parses the data for the given view
     *
     * returns {GenericViewModel}
     */
    GenericViewModel.prototype.parseData = function() {
        // BaseViewModel.prototype.parseData.call(this);
        this.viewModel = {};

        var incomingData = this.data.buttons;

        var items = [];
        var prop;

        for (prop in incomingData) {
            items.push(incomingData[prop]);
        }

        var data = items[0];

        if (data.pdfs.length < 1) {
            data.pdfs = null;
        }

        //linkify description area
        var linkifyCallBack = function (text, href) {
            return href ? '<a class="js-in-app-browser action-for-js" data-url="' + href + '" href="' + window.location.hash + '">' + text + '</a>' : text; //e.preventDefault doesn't work in android, so just make this page go to the same hash it's on...
        };

        //preferably, we'd get html from the API
        //data.description = '<a href="http://google.com">http://google.com</a> The <em>Student Activities Center</em> houses a gymnasium, some intercollegiate sports, locker rooms, showers, an outdoor swimming pool and multiple on-campus organizations.<br/>Mon-Thurs: 7:00am-11:45pm<br/>Fri: 7:00am-9:45pm<br/>Sat-Sun: 9:00am-5:45pm<br />Located east of the Wooden Center and north of Ackerman Union. www.reachmedianetwork.com';

        data.description = Linkify(data.description, { callback: linkifyCallBack }); //we need links to be our special "span" links, so they work on devices...
        
        this.viewModel.headerFixed = true;
        this.viewModel.title = data.name;
        this.viewModel.data = data;

        return this;
    };


    return GenericViewModel;
});
