/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview LeagueGamesViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var DateHandler = require('lib/DateHandler');
    var $ = require('jquery');
    //require('jquery-ui');

    var BaseViewModel = require('view-models/BaseViewModel');

    /**
     * A handler to load data to a view template.
     *
     * @name LeagueGamesViewModel
     * @class LeagueGamesViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var LeagueGamesViewModel = function(data, routeArgs) {
        if (data === null &&
            routeArgs === null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };


    /**
     * Added to make this class extend BaseViewModel
     */
    LeagueGamesViewModel.prototype = new BaseViewModel();
    LeagueGamesViewModel.prototype.constructor = LeagueGamesViewModel;


    /**
     * Parses the data for the given view
     *
     * returns {LeagueGamesViewModel}
     */
    LeagueGamesViewModel.prototype.parseData = function() {
        // BaseViewModel.prototype.parseData.call(this);
        this.viewModel = {};

        var incomingData = this.data;

        this.viewModel = {
            'section': []
        };

        var newRow = null;
        var prop = null;
        var data = null;
        var date = null;
        var rightHeader = null;
        var section = null;
        var sectionLength = null;
        var rows = null;

        for (prop in incomingData) {
            data = incomingData[prop];
            // Start new section
            if (rightHeader != DateHandler.format(data.date_time, 'rightHeader')) {
                date = data.date_time;
                rightHeader = DateHandler.format(date, 'rightHeader');
                section = {
                    'header': [{
                        'left': DateHandler.format(date, 'leftHeader'),
                        'right': rightHeader
                    }],
                    'rows': []
                };
                sectionLength = this.viewModel.section.push(section);
            }

            data.datetime = DateHandler.format(
                date,
                'datetime'
            );
            data.time = DateHandler.format(data.date_time, 'time');
            rows = this.viewModel.section[sectionLength - 1].rows;
            newRow = {
                'leagueGame': data
            };
            rows.push(newRow);
        }

        this.viewModel.si = this.routeArgs.si;
        this.viewModel.title = this.routeArgs.appButtonTitle || 'Games';

        return this;
    };


    return LeagueGamesViewModel;
});
