/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview NewsfeedViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var DateHandler = require('lib/DateHandler');
    var $ = require('jquery');
    //require('jquery-ui');

    var BaseViewModel = require('view-models/BaseViewModel');

    /**
     * A handler to load data to a view template.
     *
     * @name NewsfeedViewModel
     * @class NewsfeedViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var NewsfeedViewModel = function(data, routeArgs) {
        if (data === null &&
            routeArgs === null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };


    /**
     * Added to make this class extend BaseViewModel
     */
    NewsfeedViewModel.prototype = new BaseViewModel();
    NewsfeedViewModel.prototype.constructor = NewsfeedViewModel;


    /**
     * Parses the data for the given view
     *
     * returns {NewsfeedViewModel}
     */
    NewsfeedViewModel.prototype.parseData = function() {
        // BaseViewModel.prototype.parseData.call(this);
        this.viewModel = {
            'b': this.routeArgs.b,
            'section': []
        };

        var incomingData = this.data;

        var prop = null;
        var newRow = null;
        var data = null;
        var rows = null;

        var section = {
            'header': [],
            'rows': []
        };
        var sectionLength = this.viewModel.section.push(section);
        for (prop in incomingData) {
            data = incomingData[prop];

            data.articleId = data.id;
            data.datetime = DateHandler.format(
                data.pubDate,
                'datetime',
                false
            );

            rows = this.viewModel.section[sectionLength - 1].rows;
            newRow = {
                'feed': data
            };
            rows.push(newRow);
        }

        this.viewModel.title = this.routeArgs.appButtonTitle || 'RSS';

        return this;
    };


    return NewsfeedViewModel;
});