/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview OptionsPartialViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var $ = require('jquery');
    //require('jquery-ui');

    var BaseViewModel = require('view-models/BaseViewModel');

    /**
     * A handler to load data to a view template.
     *
     * @name OptionsPartialViewModel
     * @class OptionsPartialViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var OptionsPartialViewModel = function(data, routeArgs) {
        if (data === null &&
            routeArgs === null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };


    /**
     * Added to make this class extend BaseViewModel
     */
    OptionsPartialViewModel.prototype = new BaseViewModel();
    OptionsPartialViewModel.prototype.constructor = OptionsPartialViewModel;


    /**
     * Parses the data for the given view
     *
     * returns {OptionsPartialViewModel}
     */
    OptionsPartialViewModel.prototype.parseData = function() {
        // BaseViewModel.prototype.parseData.call(this);
        this.viewModel = {};

        switch (this.routeArgs.type) {
            case 'checkin':
                this.viewModel = {
                    'title': 'Check-In With...',
                    'options': [
                        {
                            'shareLink': SETTINGS.FACILITY_SHARE_LINK,
                            'shareText': SETTINGS.FACILITY_SHARE_TEXT,
                            'class': 'js-share-twitter',
                            'name': 'Twitter'
                        },
                        {
                            'shareLink': SETTINGS.FACILITY_SHARE_LINK,
                            'shareText': SETTINGS.FACILITY_SHARE_TEXT,
                            'class': 'js-share-facebook',
                            'name': 'Facebook'
                        }
                    ],
                    'close': {
                        'name': 'Cancel'
                    }
                };
                break;
            case 'set-reminder':
                this.viewModel = {
                    'title': 'Would you like a reminder?',
                    'options': [
                        {
                            'class': 'js-reminder',
                            'dataValue': '10',
                            'detailTitle': this.routeArgs.detailTitle,
                            'detailLocation': this.routeArgs.detailLocation,
                            'detailStart': this.routeArgs.detailStart,
                            'detailEnd': this.routeArgs.detailEnd,
                            'name': '10 Minutes'
                        },
                        {
                            'class': 'js-reminder',
                            'dataValue': '15',
                            'detailTitle': this.routeArgs.detailTitle,
                            'detailLocation': this.routeArgs.detailLocation,
                            'detailStart': this.routeArgs.detailStart,
                            'detailEnd': this.routeArgs.detailEnd,
                            'name': '15 Minutes'
                        },
                        {
                            'class': 'js-reminder',
                            'dataValue': '30',
                            'detailTitle': this.routeArgs.detailTitle,
                            'detailLocation': this.routeArgs.detailLocation,
                            'detailStart': this.routeArgs.detailStart,
                            'detailEnd': this.routeArgs.detailEnd,
                            'name': '30 Minutes'
                        },
                        {
                            'class': 'js-reminder',
                            'dataValue': '60',
                            'detailTitle': this.routeArgs.detailTitle,
                            'detailLocation': this.routeArgs.detailLocation,
                            'detailStart': this.routeArgs.detailStart,
                            'detailEnd': this.routeArgs.detailEnd,
                            'name': '1 Hour'
                        }
                    ],
                    'close': {
                        'name': 'No Reminder'
                    }
                };
                break;
            case 'share':
                this.viewModel = {
                    'title': 'Share With...',
                    'options': [
                        {
                            'shareLink': this.routeArgs.shareLink,
                            'shareText': this.routeArgs.shareText,
                            'class': 'js-share-facebook',
                            'name': 'Facebook'
                        },
                        {
                            'shareLink': this.routeArgs.shareLink,
                            'shareText': this.routeArgs.shareText,
                            'class': 'js-share-twitter',
                            'name': 'Twitter'
                        },
                        {
                            'shareLink': this.routeArgs.shareLink,
                            'shareText': this.routeArgs.shareText,
                            'class': 'js-share-email',
                            'name': 'Email'
                        },
                        {
                            'shareLink': this.routeArgs.shareLink,
                            'shareText': this.routeArgs.shareText,
                            'class': 'js-share-sms',
                            'name': 'SMS'
                        }
                    ],
                    'close': {
                        'name': 'Cancel'
                    }
                };
                break;
        }

        return this;
    };


    return OptionsPartialViewModel;
});
