/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview ScheduleViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var DateHandler = require('lib/DateHandler');
    var $ = require('jquery');
    //require('jquery-ui');

    var BaseViewModel = require('view-models/BaseViewModel');

    /**
     * A handler to load data to a view template.
     *
     * @name ScheduleViewModel
     * @class ScheduleViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var ScheduleViewModel = function(data, routeArgs) {
        if (data === null &&
            routeArgs === null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };


    /**
     * Added to make this class extend BaseViewModel
     */
    ScheduleViewModel.prototype = new BaseViewModel();
    ScheduleViewModel.prototype.constructor = ScheduleViewModel;


    /**
     * Parses the data for the given view
     *
     * returns {ScheduleViewModel}
     */
    ScheduleViewModel.prototype.parseData = function() {
        // BaseViewModel.prototype.parseData.call(this);
        this.viewModel = {
            'section': []
        };

        var incomingData = this.data.schedule;
        var newRow = null;
        var prop = null;
        var data = null;
        var date = null;
        var rightHeader = null;
        var section = null;
        var sectionLength = null;
        var rows = null;

        //todo paginate/infinite scroll for performance may be needed--android 4.3 gets wonky...otherwise limit the results
        for (prop in incomingData) {
            // Start new section
            if (rightHeader != DateHandler.formatTimestamp(incomingData[prop].start_timestamp, 'rightHeader')) {
                date = incomingData[prop].start_timestamp;
                rightHeader = DateHandler.formatTimestamp(date, 'rightHeader');
                section = {
                    'header': [{
                        'left': DateHandler.formatTimestamp(date, 'leftHeader'),
                        'right': rightHeader
                    }],
                    'rows': []
                };
                sectionLength = this.viewModel.section.push(section);
            }

            incomingData[prop].time = DateHandler.formatTimestamp(incomingData[prop].start_timestamp, 'time');
            rows = this.viewModel.section[sectionLength - 1].rows;
            newRow = {
                'event': incomingData[prop]
            };
            rows.push(newRow);
        }

        this.viewModel.title = this.routeArgs.appButtonTitle || 'Schedule';
        return this;
    };


    return ScheduleViewModel;
});
