/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview SettingsViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var $ = require('jquery');
    //require('jquery-ui');

    var BaseViewModel = require('view-models/BaseViewModel');

    /**
     * A handler to load data to a view template.
     *
     * @name SettingsViewModel
     * @class SettingsViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var SettingsViewModel = function(data, routeArgs) {
        if (data === null &&
            routeArgs === null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };


    /**
     * Added to make this class extend BaseViewModel
     */
    SettingsViewModel.prototype = new BaseViewModel();
    SettingsViewModel.prototype.constructor = SettingsViewModel;


    /**
     * Parses the data for the given view
     *
     * returns {SettingsViewModel}
     */
    SettingsViewModel.prototype.parseData = function() {
        // BaseViewModel.prototype.parseData.call(this);
        this.viewModel = {};

        var tellAFriendMailQueryObject = {
            'subject': 'Tell a Friend',
            'body': SETTINGS.FACILITY_TELL_A_FRIEND_BODY
        };
        var tellAFriendMailQueryString = $.param(tellAFriendMailQueryObject);

        var title = this.routeArgs.appButtonTitle || 'Settings';
        tellAFriendMailQueryString = tellAFriendMailQueryString.replace(/\+/g, '%20');
        this.viewModel = {
            'title': title,
            'section': [
                {
                    'header': 'Account',
                    'rows': [
                        {
                            'name': 'Push Notifications',
                            'link': '#' + Views.ToggleNotifications
                        },
                        {
                            'name': 'Change Location',
                            'link': '#' + Views.SetPreferredLocation
                        }
                    ]
                },
                {
                    'header': 'General',
                    'rows': [
                        {
                            'name': 'About',
                            'link': '#about'
                        },
                        {
                            'name': 'Tell A Friend',
                            'link': 'mailto:?' +
                                tellAFriendMailQueryString,
                            'target': '_blank'
                        },
                        {
                            'name': 'Feedback',
                            'link': '#feedback'
                        }
                    ]
                }
            ]
        };

        return this;
    };


    return SettingsViewModel;
});
