/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview ToggleNotificationsViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var $ = require('jquery');
    //require('jquery-ui');
    var NotificationTags = require('lib/NotificationTags');

    var BaseViewModel = require('view-models/BaseViewModel');

    /**
     * A handler to load data to a view template.
     *
     * @name ToggleNotificationsViewModel
     * @class ToggleNotificationsViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var ToggleNotificationsViewModel = function(data, routeArgs) {
        if (data === null &&
            routeArgs === null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };


    /**
     * Added to make this class extend BaseViewModel
     */
    ToggleNotificationsViewModel.prototype = new BaseViewModel();
    ToggleNotificationsViewModel.prototype.constructor = ToggleNotificationsViewModel;


    /**
     * Parses the data for the given view
     *
     * returns {ToggleNotificationsViewModel}
     */
    ToggleNotificationsViewModel.prototype.getData = function () {
        var dfd = $.Deferred();

        // BaseViewModel.prototype.parseData.call(this);
        this.viewModel = {};

        var rows = [];
        NotificationTags.getTags().then(function (incomingData) {
            for (var prop in incomingData) {
                rows.push(incomingData[prop]);
            }

            // Necessary because push notifications are in iOS settings
            var pushService = null;
            if (device.platform != 'iOS') {
                pushService = {
                    'title': 'Push Notification Service',
                    'id': 'push-service',
                    'name': 'Push Enabled',
                    'isChecked': NotificationTags.getIsPushEnabled()
                };
            }

            this.viewModel = {
                'title': 'Push Notifications',
                'pushService': pushService,
                'tagTitle': 'Tags',
                'rows': rows
            };

            dfd.resolve();
        }.bind(this));

        return dfd.promise();
    };


    return ToggleNotificationsViewModel;
});
