/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview UpcomingEventsViewModel module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var DateHandler = require('lib/DateHandler');
    var $ = require('jquery');
    //require('jquery-ui');

    var BaseViewModel = require('view-models/BaseViewModel');

    /**
     * A handler to load data to a view template.
     *
     * @name UpcomingEventsViewModel
     * @class UpcomingEventsViewModel A handler to load data to a view template.
     * @constructor
     * @param {object} data The data object returned from the backend API
     * @param {object} routeArgs The query object passed to the view via the route
     */
    var UpcomingEventsViewModel = function(data, routeArgs) {
        if (data === null &&
            routeArgs === null) {

            return;
        }

        this.data = data;
        this.routeArgs = routeArgs;

        this.init();
    };


    /**
     * Added to make this class extend BaseViewModel
     */
    UpcomingEventsViewModel.prototype = new BaseViewModel();
    UpcomingEventsViewModel.prototype.constructor = UpcomingEventsViewModel;


    /**
     * Parses the data for the given view
     *
     * returns {UpcomingEventsViewModel}
     */
    UpcomingEventsViewModel.prototype.parseData = function() {
        // BaseViewModel.prototype.parseData.call(this);
        this.viewModel = {};

        var incomingData = this.data;

        this.viewModel = {
            'section': []
        };

        var prop = null;
        var newRow = null;
        var data = null;
        var rows = null;

        var section = {
            'header': [],
            'rows': []
        };
        var sectionLength = this.viewModel.section.push(section);

        for (prop in incomingData) {
            data = incomingData[prop];
                
            if("" == data.start_timestamp && "" == data.end_timestamp) {
            	data.time = false;
            	data.datetime = false;
            } else {
                data.time =
                	DateHandler.formatTimestamp(data.start_timestamp, 'time');
            	data.datetime = DateHandler.formatTimestamp(
                	data.start_timestamp,
                	'datetime'
            	);
            }

            rows = this.viewModel.section[sectionLength - 1].rows;
            newRow = {
                'upcomingEvent': data
            };
            rows.push(newRow);
        }

        this.viewModel.buttonId = this.routeArgs.b;
        this.viewModel.title = this.routeArgs.appButtonTitle || 'Upcoming Events';

        return this;
    };


    return UpcomingEventsViewModel;
});
