/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/* global define */

/**
 * @fileOverview DetailView module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var Views = require('lib/Views');
    var $ = require('jquery');

    var features = require('models/FeatureAdapter');

    var BaseView = require('views/BaseView');
    var addCalendarEvent = require('lib/addCalendarEvent');

    /**
     * A detail page view script. Handles button functionality.
     *
     * @name DetailView
     * @class DetailView A detail page view script. Handles button functionality.
     * @constructor
     * @param {jQuery} $element A reference to the containing DOM element
     */
    var DetailView = function($element) {
        /**
         * A reference to the containing DOM element
         *
         * @default null
         * @name $element
         * @type {jQuery}
         */
        this.$element = $element;

        /**
         * Tracks whether component is enabled.
         *
         * @default false
         * @name isEnabled
         * @type {bool}
         */
        this.isEnabled = false;

        this.init();
    };


    /**
     * Added to make this class extend BaseView
     */
    DetailView.prototype = new BaseView();
    DetailView.prototype.constructor = DetailView;


    /**
     * Initializes the UI Component View
     * Runs a single setupHandlers call, followed by createChildren and layout
     * Exits early if it is already initialized
     *
     * returns {DetailView}
     */
    DetailView.prototype.init = function() {
        BaseView.prototype.init.call(this);

        return this;
    };

    /**
     * Binds the scope of any handler functions
     * Should only be run on initialization of the view
     *
     * returns {DetailView}
     */
    DetailView.prototype.setupHandlers = function() {
        BaseView.prototype.setupHandlers.call(this);

        this.onAddToCalendarClickHandler = this.onAddToCalendarClick.bind(this);
        this.onSetReminderClickHandler = this.onSetReminderClick.bind(this);
        this.onShareClickHandler = this.onShareClick.bind(this);

        return this;
    };

    /**
     * Create any child objects or references to DOM elements
     * Should only be run on initialization of the view
     *
     * @returns {DetailView}
     */
    DetailView.prototype.createChildren = function() {
        BaseView.prototype.createChildren.call(this);

        this.$window = $(window);

        this.$addToCalendar = this.$element.find('.js-add-to-calendar');
        this.$setReminder = this.$element.find('.js-set-reminder');
        this.$share = this.$element.find('.js-share');

        return this;
    };

    /**
     * Remove any child objects or references to DOM elements
     *
     * @returns {DetailView}
     */
    DetailView.prototype.removeChildren = function() {
        BaseView.prototype.removeChildren.call(this);

        this.$window = null;

        this.$addToCalendar = null;
        this.$setReminder = null;
        this.$share = null;

        return this;
    };

    /**
     * Performs measurements and applys any positioning style logic
     * Should be run anytime the parent layout changes
     *
     * @returns {DetailView}
     */
    DetailView.prototype.layout = function() {
        BaseView.prototype.layout.call(this);

        return this;
    };

    /**
     * Enables the component
     * Performs any event binding to handlers
     * Exits early if it is already enabled
     *
     * @returns {DetailView}
     */
    DetailView.prototype.enable = function() {
        BaseView.prototype.enable.call(this);

        this.$addToCalendar
            .on(features.TAP, this.onAddToCalendarClickHandler);

        this.$setReminder
            .on(features.TAP, this.onSetReminderClickHandler);

        this.$share
            .on(features.TAP, this.onShareClickHandler);

        return this;
    };

    /**
     * Disables the component
     * Tears down any event binding to handlers
     * Exits early if it is already disabled
     *
     * @returns {DetailView}
     */
    DetailView.prototype.disable = function() {
        BaseView.prototype.disable.call(this);

        this.$addToCalendar
            .off(features.TAP, this.onAddToCalendarClickHandler);

        this.$setReminder
            .off(features.TAP, this.onSetReminderClickHandler);

        this.$share
            .off(features.TAP, this.onShareClickHandler);

        return this;
    };

    /**
     * Destroys the component
     * Tears down any events, handlers, elements
     * Should be called when the object should be left unused
     *
     * @returns {DetailView}
     */
    DetailView.prototype.destroy = function() {
        BaseView.prototype.destroy.call(this);

        return this;
    };

    //////////////////////////////////////////////////////////////////////////////////
    // EVENT HANDLERS
    //////////////////////////////////////////////////////////////////////////////////

    /**
     * onAddToCalendarClick handler
     * Handles the click event of the add to calendar button
     *
     * @param {Event} e JavaScript event object
     */
    DetailView.prototype.onAddToCalendarClick = function(event) {
        event.preventDefault();

        var $button = $(event.currentTarget);
        var details = {};

        details.title = $button.data('detail-title') || '';
        details.location = $button.data('detail-location') || '';
        details.notes = '';
        details.start = $button.data('detail-start') || '';
        details.end = $button.data('detail-end') || '';

        // add event with no reminder
        addCalendarEvent(details, null);
    };

    /**
     * onSetReminderClick handler
     * Handles the click event of the set reminder button
     *
     * @param {Event} e JavaScript event object
     */
    DetailView.prototype.onSetReminderClick = function(event) {
        event.preventDefault();
        var $button = $(event.currentTarget);

        // Trigger the showPartialTemplate event on the window
        var queryObject = {
          'type': 'set-reminder',
          'detailTitle': $button.data('detail-title'),
          'detailStart': $button.data('detail-start'),
          'detailEnd': $button.data('detail-end'),
          'detailLocation': $button.data('detail-location')
        };
        var route = Views.OptionsPartial + '?' + $.param(queryObject);

        // This event is handled by the RouteHandler
        this.$window.trigger(
            'showPartialTemplate',
            [
                this.optionsOnRecieveDataCallbackHandler,
                route
            ]
        );

    };

    /**
     * onShareClick handler
     * Handles the click event of the share button
     *
     * @param {Event} e JavaScript event object
     */
    DetailView.prototype.onShareClick = function(event) {
        event.preventDefault();
        var $button = $(event.currentTarget);

        // Trigger the showPartialTemplate event on the window
        var queryObject = {
          'type': 'share',
          'shareLink': $button.data('share-link'),
          'shareText': $button.data('share-text')
        };
        var route = Views.OptionsPartial + '?' + $.param(queryObject);

        // This event is handled by the RouteHandler
        this.$window.trigger(
            'showPartialTemplate',
            [
                this.optionsOnRecieveDataCallbackHandler,
                route
            ]
        );
    };

    return DetailView;
});
