/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview FeedbackView module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var $ = require('jquery');
    //require('jquery-ui');

    var features = require('models/FeatureAdapter');

    var BaseView = require('views/BaseView');

    /**
     * A detail page view script. Handles button functionality.
     *
     * @name FeedbackView
     * @class FeedbackView A detail page view script. Handles button functionality.
     * @constructor
     * @param {jQuery} $element A reference to the containing DOM element
     */
    var FeedbackView = function($element) {
        /**
         * A reference to the containing DOM element
         *
         * @default null
         * @name $element
         * @type {jQuery}
         */
        this.$element = $element;

        /**
         * Tracks whether component is enabled.
         *
         * @default false
         * @name isEnabled
         * @type {bool}
         */
        this.isEnabled = false;

        this.apiUrl = SETTINGS.API_URL;

        this.init();
    };

    /**
     * Added to make this class extend BaseView
     */
    FeedbackView.prototype = new BaseView();
    FeedbackView.prototype.constructor = FeedbackView;


    /**
     * Initializes the UI Component View
     * Runs a single setupHandlers call, followed by createChildren and layout
     * Exits early if it is already initialized
     *
     * returns {FeedbackView}
     */
    FeedbackView.prototype.init = function() {
        BaseView.prototype.init.call(this);

        return this;
    };

    /**
     * Binds the scope of any handler functions
     * Should only be run on initialization of the view
     *
     * returns {FeedbackView}
     */
    FeedbackView.prototype.setupHandlers = function() {
        BaseView.prototype.setupHandlers.call(this);

        this.onFormSubmitButtonClickHandler =
            this.onFormSubmitButtonClick.bind(this);
        this.onFormSubmitHandler = this.onFormSubmit.bind(this);
        this.onFormSubmitSuccessHandler = this.onFormSubmitSuccess.bind(this);
        this.onFormSubmitFailHandler = this.onFormSubmitFail.bind(this);

        return this;
    };

    /**
     * Create any child objects or references to DOM elements
     * Should only be run on initialization of the view
     *
     * @returns {FeedbackView}
     */
    FeedbackView.prototype.createChildren = function() {
        BaseView.prototype.createChildren.call(this);

        this.$formSubmitButton = $('.js-submit-feedback-form');
        this.$form = this.$element.find('.js-feedback-form');

        return this;
    };

    /**
     * Remove any child objects or references to DOM elements
     *
     * @returns {FeedbackView}
     */
    FeedbackView.prototype.removeChildren = function() {
        BaseView.prototype.removeChildren.call(this);

        this.$formSubmitButton = null;
        this.$form = null;

        return this;
    };

    /**
     * Performs measurements and applys any positioning style logic
     * Should be run anytime the parent layout changes
     *
     * @returns {FeedbackView}
     */
    FeedbackView.prototype.layout = function() {
        BaseView.prototype.layout.call(this);

        return this;
    };

    /**
     * Enables the component
     * Performs any event binding to handlers
     * Exits early if it is already enabled
     *
     * @returns {FeedbackView}
     */
    FeedbackView.prototype.enable = function() {
        BaseView.prototype.enable.call(this);

        this.$formSubmitButton.on(
            features.TAP,
            this.onFormSubmitButtonClickHandler
        );

        this.$form.on(
            'submit',
            this.onFormSubmitHandler
        );

        return this;
    };

    /**
     * Disables the component
     * Tears down any event binding to handlers
     * Exits early if it is already disabled
     *
     * @returns {FeedbackView}
     */
    FeedbackView.prototype.disable = function() {
        BaseView.prototype.disable.call(this);

        this.$formSubmitButton.off(
            features.TAP,
            this.onFormSubmitButtonClickHandler
        );

        this.$form.off(
            'submit',
            this.onFormSubmitHandler
        );

        return this;
    };

    /**
     * Destroys the component
     * Tears down any events, handlers, elements
     * Should be called when the object should be left unused
     *
     * @returns {FeedbackView}
     */
    FeedbackView.prototype.destroy = function() {
        BaseView.prototype.destroy.call(this);

        return this;
    };

    //////////////////////////////////////////////////////////////////////////////////
    // EVENT HANDLERS
    //////////////////////////////////////////////////////////////////////////////////

    /**
     * onFormSubmitButtonClick handler
     * Handles the form submission click event
     *
     * @param {Event} e JavaScript event object
     */
    FeedbackView.prototype.onFormSubmitButtonClick = function(event) {
        event.preventDefault();

        //var formData = this.$form.serializeArray();
        var form = this.$form[0];
        var message = $.trim(form.message.value);
        var sender = $.trim(form.sender.value);

        if (message == '') {
            navigator.notification.alert(
                'Please enter a message',
                function() {},
                'Error',
                'Close'
            );
            return;
        }

        var data = {
            'p': SETTINGS.FACILITY_ID,
            'method': 'put_feedback',
            'msg': message,
            'coninfo': sender
        };

        var jqxhr = $.ajax({
            url: this.apiUrl,
            data: data,
            type: 'GET'
        })
        .done(
            this.onFormSubmitSuccessHandler
        )
        .fail(
            this.onFormSubmitFailHandler
        );
    };

    /**
     * onFormSubmitSuccess handler
     * Handles the form submission success
     *
     * @param {Event} e JavaScript event object
     */
    FeedbackView.prototype.onFormSubmitSuccess = function(data) {
        var parsedJson = Util.parseAjaxJson(data);

        if (parsedJson != null && parsedJson.status == 1) {
            navigator.notification.alert(
                'Your feedback has been submitted',
                function() {},
                'Success',
                'Close'
            );
            this.$form.get(0).reset();

            return;
        }

        navigator.notification.alert(
            'Please try again later',
            function() {},
            'Error',
            'Close'
        );
    };

    /**
     * onFormSubmitFail handler
     * Handles the form submission fail
     *
     * @param {Event} e JavaScript event object
     */
    FeedbackView.prototype.onFormSubmitFail = function (error) {
        navigator.notification.alert(
            'Unable to hit Api\r\nPlease try again later',
            function() {},
            'Error',
            'Close'
        );
    };

    /**
     * onFormSubmit handler
     * Handles the form submission for the feedback form
     *
     * @param {Event} e JavaScript event object
     */
    FeedbackView.prototype.onFormSubmit = function(event) {
        event.preventDefault();
        event.stopPropagation();
    };

    return FeedbackView;
});
