/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

define(function(require, module, exports) {
    'use strict';

    var LABEL_SELECTOR = '.pullDownLabel';

    var FLIP_THRESHOLD = 5;
    var VIEW_STATES = {
        DEFAULT: 0,
        FLIPPED: 1,
        LOADING: 2
    };

    var VIEW_CLASSES = {
        0: null,
        1: 'flip',
        2: 'loading'
    };

    var VIEW_TEXT = {
        0: 'Pull down to refresh...',
        1: 'Release to refresh...',
        2: 'Loading...'
    };

    var ListingPullToRefreshView = function($element) {
        if (typeof $element === 'undefined') {
            throw new TypeError('$element must be provided');
        }

        this.init($element);
    };

    ListingPullToRefreshView.prototype.init = function($element) {
        this.isEnabled = false;
        this.$element = $element;
        this.state = VIEW_STATES.DEFAULT;

        return this.createChildren()
                   .layout();
    };

    ListingPullToRefreshView.prototype.setupHandlers = function() {
        this.onScrollViewHasMovedHandler = $.proxy(this.onScrollViewHasMoved, this);
        this.onScrollViewDidFinishMovingHandler = $.proxy(this.onScrollViewDidFinishMoving, this);

        return this;
    };

    ListingPullToRefreshView.prototype.createChildren = function() {
        this.$label = this.$element.find(LABEL_SELECTOR);

        return this;
    };

    ListingPullToRefreshView.prototype.layout = function() {
        return this;
    };

    ListingPullToRefreshView.prototype.destroy = function() {

        return this;
    };

    ListingPullToRefreshView.prototype.getHeight = function() {
        return this.$element.outerHeight();
    };

    ListingPullToRefreshView.prototype.setState = function(state) {
        if (this.state === state) {
            return this;
        }

        this.$element.hide();

        if (VIEW_CLASSES[this.state]) {
            this.$element.removeClass(VIEW_CLASSES[this.state]);
        }

        this.state = state;
        this.$element.addClass(VIEW_CLASSES[state]);
        this.$label.html(VIEW_TEXT[state]);

        this.$element.show();
    };

    ListingPullToRefreshView.prototype.onScrollViewHasMoved = function (scrollView) {
        if (scrollView.y > FLIP_THRESHOLD && this.state !== VIEW_STATES.FLIPPED) {
            this.setState(VIEW_STATES.FLIPPED);
            scrollView.minScrollY = 0;
        } else if (scrollView.y < FLIP_THRESHOLD && this.state === VIEW_STATES.FLIPPED) {
            this.setState(VIEW_STATES.DEFAULT);

            scrollView.minScrollY = -this.getHeight();
        }
    };

    ListingPullToRefreshView.prototype.onScrollViewDidFinishMoving = function(scrollView, listingView) {
        if (this.state === VIEW_STATES.FLIPPED) {
            this.setState(VIEW_STATES.LOADING);

            // Normally, this would be performed with event listeners
            // Because this is android real-time code, we need to be extra diligent
            listingView.requestNavigationChange();

            // Removed this to fix an issue with the loading action scrolling the listing
            // scrollView.refresh();
        }
    };

    ListingPullToRefreshView.SELECTOR = '.js-pullDown';

    return ListingPullToRefreshView;
});
