/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview ListingView module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var $ = require('jquery');
    var IScroll = require('iscroll');
    //require('jquery-ui');

    var features = require('models/FeatureAdapter');

    var BaseView = require('views/BaseView');
    var ListingPullToRefreshView = require('views/ListingPullToRefreshView');
    var Handlebars = require('handlebars');

    var LISTING_DATA_SELECTOR = '.js-data-listing';
    var LISTING_PARTIAL_SELECTOR = '.js-listing-partial';
    var SCROLL_VIEW_WRAPPER_SELECTOR = '.iscrollWrapper';
    var SCROLL_START_CLASS = 'js-iscroll-start';
    var SCROLL_VIEW_NO_ANIMATION_CLASS = 'scrollView-noAnimation';
    var LISTING_BUTTON_SELECTOR = '.js-listing-button';
    var LISTING_BUTTON_SELECT_SELECTOR = '.js-listing-button-select';
    var LISTING_IN_APP_BROWSER_BUTTON_SELECTOR = '.js-listing-in-app-browser';
    var STICKY_HEADER_SELECTOR = '.js-sticky-header';
    var MAIN_LISTING_VIEW_WRAPPER_SELECTOR = '.js-listingView-wrapper';
    var STICKY_HEADER_NODE_SELECTOR = '.js-stickyHeader-node';

    var VIEWPORT_PADDING = 15;

    var BODY = document.body;
    var $window = $(window);

    /**
     * A base view script.
     *
     * @name ListingView
     * @class ListingView A base view script.
     * @constructor
     * @param {jQuery} $element A reference to the containing DOM element
     */
    var ListingView = function($element) {
        /**
         * A reference to the containing DOM element
         *
         * @default null
         * @name $element
         * @type {jQuery}
         */
        this.$element = $element;
        /**
         * Tracks whether component is enabled.
         *
         * @default false
         * @name isEnabled
         * @type {bool}
         */
        this.isEnabled = false;

        this.init();
    };

    /**
     * Added to make this class extend BaseView
     */
    ListingView.prototype = new BaseView();
    ListingView.prototype.constructor = ListingView;

    /**
     * Initializes the UI Component View
     * Runs a single setupHandlers call, followed by createChildren and layout
     * Exits early if it is already initialized
     *
     * returns {ListingView}
     */
    ListingView.prototype.init = function () {
        BaseView.prototype.init.call(this);

        return this;
    };

    /**
     * Binds the scope of any handler functions
     * Should only be run on initialization of the view
     *
     * returns {ListingView}
     */
    ListingView.prototype.setupHandlers = function() {
        BaseView.prototype.setupHandlers.call(this);

        this.onListingButtonTapHandler = this.onListingButtonTap.bind(this);
        this.onListingButtonSelectTapHandler = this.onListingButtonSelectTap.bind(this);
        this.onListingButtonInAppBrowserTapHandler =
            this.onListingButtonInAppBrowserTap.bind(this);

        this.onScrollStartHandler = this.onScrollStart.bind(this);
        this.onScrollMoveHandler = this.onScrollMove.bind(this);
        this.onScrollEndHandler = this.onScrollEnd.bind(this);
        this.onScrollInteractionEndHandler = this.onScrollInteractionEnd.bind(this);

        this.onSearchHandler = this.onSearch.bind(this);
        this.onListRefreshHandler = this.onListRefresh.bind(this);
        this.onClearSearchTextHandler = this.onClearSearchText.bind(this);
        this.onSearchTextBlurHandler = this.onSearchTextBlur.bind(this);

        return this;
    };

    /**
     * Create any child objects or references to DOM elements
     * Should only be run on initialization of the view
     *
     * @returns {ListingView}
     */
    ListingView.prototype.createChildren = function() {
        BaseView.prototype.createChildren.call(this);

        this.$stickyHeaderNode = this.$element.find(STICKY_HEADER_NODE_SELECTOR);

        this.$pullToRefresh = this.$element.find(ListingPullToRefreshView.SELECTOR);
        this.$listing = this.$element.find(LISTING_DATA_SELECTOR);

        // Added to remove corners on android.
        if (device.platform == 'Android') {
            this.$listing.addClass('ctrls-noCorners');
            this.$stickyHeaderNode.addClass('ctrls-noCorners');
        }

        this.$listingPartial = this.$element.find(LISTING_PARTIAL_SELECTOR);
        this.$scrollViewWrapper = this.$listing.find(SCROLL_VIEW_WRAPPER_SELECTOR);
        this.$scrollViewWrapper.addClass(SCROLL_START_CLASS);

        this.$headerContainer = this.$element.find('#headerSearchContainer');

        this.$listingButtons = this.$element.find(LISTING_BUTTON_SELECTOR);
        this.$listingButtonSelects = this.$element.find(LISTING_BUTTON_SELECT_SELECTOR);
        this.$listingInAppBrowserButtons = this.$element.find(LISTING_IN_APP_BROWSER_BUTTON_SELECTOR);
        this.$headers = this.$element.find(STICKY_HEADER_SELECTOR);

        if (this.$headers != null) {
            this.$activeHeader = null;
            this.$nextHeader = this.$headers.eq(0);
        }

        // Calculate the viewport before creating the scrollView
        
        this.calculateViewport();
        this.createScrollView();
        
        this.$txtSearch = this.$element.find('#txtSearch');
        this.$searchCancel = this.$element.find('#searchCancel');

        return this;
    };

    ListingView.prototype.createScrollView = function() {

        var pullToRefresh = this.pullToRefresh = new ListingPullToRefreshView(this.$pullToRefresh);
        var $scrollViewWrapper = this.$scrollViewWrapper;

        $scrollViewWrapper.addClass(SCROLL_VIEW_NO_ANIMATION_CLASS);

        //Util.log('createScrollView: ' + this.$listing.get(0).offsetWidth + 'x' + this.$listing.get(0).offsetHeight);
        this.scrollView = new IScroll(this.$listing.get(0), {
            topOffset: pullToRefresh.getHeight(),
            useTransform: true,
            useTransition: true
        });
        

        this.scrollView.scrollTo(0, -this.pullToRefresh.getHeight(), 0);

        // Remove this on the next loop otherwise it will trigger an animation
        this.runOnNextEventLoop(function() {
            $scrollViewWrapper.removeClass(SCROLL_VIEW_NO_ANIMATION_CLASS);
        });

        return this;
    };

    /**
     * Remove any child objects or references to DOM elements
     *
     * @returns {ListingView}
     */
    ListingView.prototype.removeChildren = function() {
        BaseView.prototype.removeChildren.call(this);

        this.$stickyHeaderNode = null;

        this.$pullToRefresh = null;
        this.$listing = null;
        this.$listingPartial = null;
        this.$scrollViewWrapper = null;

        this.$headerContainer = null;

        this.$listingButtons = null;
        this.$listingButtonSelects = null;
        this.$listingInAppBrowserButtons = null;
        this.$headers = null;

        this.$activeHeader = null;
        this.$nextHeader = null;

        this.$txtSearch = null;
        this.$searchCancel = null;

        return this;
    };

    /**
     * Runs the specified operation immediately on the next event loop
     *
     * @method runOnNextEventLoop
     * @property {function} operation
     * @chainable
     */
    ListingView.prototype.runOnNextEventLoop = function(operation) {
        setTimeout(operation, 0);
    };

    /**
     * Performs measurements and applys any positioning style logic
     * Should be run anytime the parent layout changes
     *
     * @returns {ListingView}
     */
    ListingView.prototype.layout = function() {
        BaseView.prototype.layout.call(this);

        this.calculateViewport();
    
        this.scrollView.refresh();

        return this;
    };

    ListingView.prototype.calculateViewport = function() {
        var viewportHeight = BODY.offsetHeight - this.$headerContainer.get(0).offsetHeight - VIEWPORT_PADDING;
        this.$listing.height(viewportHeight);

        // Added to handle pages which do not have enough data to reach the page height
        var listingPartialHeight = this.$listingPartial.height();
        if (listingPartialHeight > 0 && listingPartialHeight < viewportHeight) {
            this.$scrollViewWrapper.height(viewportHeight + this.$pullToRefresh.outerHeight());
            this.$listingPartial.height(viewportHeight);
        } else {
            this.$scrollViewWrapper.css('height', '');
            this.$listingPartial.css('height', '');
        }
    };

    /**
     * Enables the component
     * Performs any event binding to handlers
     * Exits early if it is already enabled
     *
     * @returns {ListingView}
     */
    ListingView.prototype.enable = function() {
        BaseView.prototype.enable.call(this);

        this.scrollView.on('scrollStart', this.onScrollStartHandler);
        this.scrollView.on('scrollEnd', this.onScrollEndHandler);
        this.scrollView.on('scrollCancel', this.onScrollEndHandler);
        this.scrollView.on('interactionEnd', this.onScrollInteractionEndHandler);

        this.$listingInAppBrowserButtons.on(features.TAP, this.onListingButtonInAppBrowserTapHandler);
        this.$listingButtons.on(features.TAP, this.onListingButtonTapHandler);
        this.$listingButtonSelects.on(features.TAP, this.onListingButtonSelectTapHandler);

        this.$txtSearch.on('keyup', this.onSearchHandler);
        this.$txtSearch.on('blur', this.onSearchTextBlurHandler);
        $window.on('listRefresh', this.onListRefreshHandler);
        this.$searchCancel.on(features.CLICK, this.onClearSearchTextHandler);

        return this;
    };

    /**
     * Disables the component
     * Tears down any event binding to handlers
     * Exits early if it is already disabled
     *
     * @returns {ListingView}
     */
    ListingView.prototype.disable = function() {
        BaseView.prototype.disable.call(this);

        this.scrollView.off('scrollStart', this.onScrollStartHandler);
        this.scrollView.off('scrollEnd', this.onScrollEndHandler);
        this.scrollView.off('scrollCancel', this.onScrollEndHandler);
        this.scrollView.off('interactionEnd', this.onScrollInteractionEndHandler);

        this.$listingInAppBrowserButtons.off(features.TAP, this.onListingButtonInAppBrowserTapHandler);
        this.$listingButtons.off(features.TAP, this.onListingButtonTapHandler);
        this.$listingButtonSelects.off(features.TAP, this.onListingButtonSelectTapHandler);

        this.$txtSearch.off('keyup', this.onSearchHandler);
        this.$txtSearch.off('blur', this.onSearchTextBlurHandler);
        $window.off('listRefresh', this.onListRefreshHandler);
        this.$searchCancel.off(features.CLICK, this.onClearSearchTextHandler);

        return this;
    };

    /**
     * Destroys the component
     * Tears down any events, handlers, elements
     * Should be called when the object should be left unused
     *
     * @returns {ListingView}
     */
    ListingView.prototype.destroy = function () {
        BaseView.prototype.destroy.call(this);

        if (this.scrollingListenerInterval) {
            clearInterval(this.scrollingListenerInterval);
        }

        //clean up scrollview
        this.scrollView.destroy();
        this.scrollView = null;

        return this;
    };

    ListingView.prototype.requestNavigationChange = function($target) {
        var payload;
        var eventName = 'onListingHashChange';
        if (typeof $target !== 'undefined') {
            payload = [$target];
            eventName = 'onNavigationButtonClick';
        }

        $window.trigger(eventName, payload);
    };

    //makes top header display current section header info (date info)
    ListingView.prototype.updateHeaderPosition = function() {
        if (this.$headers == null) {
            return;
        }

        var didFindHeader = false;
        this.scrollView.checkDOMChanges = false;

        if (this.$nextHeader && this.$nextHeader.position() && this.$nextHeader.position().top < 0) {
            this.showStickyHeader(this.$nextHeader);
            this.$activeHeader = this.$nextHeader;
            didFindHeader = true;

            var nextHeaderIndex = this.$headers.index(this.$nextHeader) + 1;
            if (nextHeaderIndex < this.$headers.length) {
                this.$nextHeader = this.$headers.eq(nextHeaderIndex);
            } else {
                this.$nextHeader = null;
            }
        }

        if (!didFindHeader && this.$activeHeader && this.$activeHeader.position() && this.$activeHeader.position().top > 0) {
            this.$nextHeader = this.$activeHeader;

            var previousHeaderIndex = this.$headers.index(this.$activeHeader) - 1;
            if (previousHeaderIndex >= 0) {
                this.$activeHeader = this.$headers.eq(previousHeaderIndex);
            } else {
                this.$activeHeader = null;
            }

            this.showStickyHeader(this.$activeHeader);
        }

        this.scrollView.checkDOMChanges = true;
    };

    ListingView.prototype.showStickyHeader = function($header) {
        this.$stickyHeaderNode.empty();

        if ($header !== null) {
            this.$stickyHeaderNode.append($header.clone());
        }

        return this;
    };

    //////////////////////////////////////////////////////////////////////////////////
    // EVENT HANDLERS
    //////////////////////////////////////////////////////////////////////////////////

    ListingView.prototype.onListingButtonInAppBrowserTap = function(event) {
        if (this.scrollView.moved) {
            return;
        }

        var $button = $(event.currentTarget);

        var url = Util.assureHttp($button.data('url'));
        Util.windowOpen(url, '_blank', 'location=no,EnableViewPortScale=yes');
    };

    ListingView.prototype.onListingButtonTap = function(event) {
        if (this.scrollView.moved) {
            return;
        }

        var $button = $(event.currentTarget);

        this.requestNavigationChange($button);
    };

    ListingView.prototype.onListingButtonSelectTap = function (event) {
        if (this.scrollView.moved) {
            return;
        }

        var $button = $(event.currentTarget);
        this.$listingButtonSelects.removeClass('selected');
        $window.trigger('onButtonSelectTap', [$button]);
    };

    ListingView.prototype.onScrollStart = function () {
        if (this.scrollingListenerInterval) {
            clearInterval(this.scrollingListenerInterval);
            this.scrollingListenerInterval = null;
        }

        this.scrollingListenerInterval = setInterval(this.onScrollMoveHandler);
    };

    ListingView.prototype.onScrollMove = function() {
        this.updateHeaderPosition();
        if (this.scrollView.initiated) {
            this.pullToRefresh.onScrollViewHasMoved(this.scrollView);
        }
    };

    ListingView.prototype.onScrollEnd = function() {
        if (this.scrollingListenerInterval) {
            clearInterval(this.scrollingListenerInterval);
            this.scrollingListenerInterval = null;
        }

        this.updateHeaderPosition();
    };

    ListingView.prototype.onScrollInteractionEnd = function() {
        this.pullToRefresh.onScrollViewDidFinishMoving(this.scrollView, this);
    };

    ListingView.prototype.onSearch = function () {
        var search = this._getSearchText();

        //toggle the clear search x. the x button doesn't fire on iOS
        search !== '' ? this.$searchCancel.show() : this.$searchCancel.hide(); //&& device.platform != 'iOS'

        //wait a bit before searching...
        if (this.searchTimeout) {
            clearTimeout(this.searchTimeout);
        }

        this.searchTimeout = setTimeout(function() {
            //tell routehandler to give us the viewdata in the listRefresh handler
            Util.log('Searching...');
            $window.trigger('listSearch');
        }, 300);
    };

    ListingView.prototype.onListRefresh = function(event, viewTemplateData) {
        var search = this._getSearchText();
        var data = viewTemplateData.viewData;
        var filteredData = { section: [] };

        //filter data
        if (search !== '') {
            var filteredRows, section, row;
            for (var i = 0, ilength = data.section.length; i < ilength; i++) {
                section = data.section[i];
                filteredRows = [];
                for (var j = 0, jlength = section.rows.length; j < jlength; j++) {
                    row = section.rows[j];
                    //if any of the row's property values contain the search, good to go
                    if (this._search(row, search)) {
                        filteredRows.push(row);
                    }
                }

                //only add a section, if at least one section row matched the search
                if (filteredRows.length > 0) {
                    filteredData.section.push({
                        header: section.header,
                        rows: filteredRows
                    });
                }
            }
        } else {
            filteredData.section = data.section;
        }

        //rebind template with new data
        var compiledTemplate = Handlebars.templates['listing-partial'];
        this.$listingPartial.html(compiledTemplate(filteredData));

        //reset the view (hook up event handlers and iScroll)
        this.destroy().init();
        this.$stickyHeaderNode.empty(); //also empty the sticky header
    };

    //recursively iterates through all plain properties values of the obj and returns true as soon as it finds a match, otherwise returns false 
    //case-insensitive
    //consider having a list of excluded properties that the search should skip
    ListingView.prototype._search = function(obj, search) {
        if ($.isArray(obj)) {
            //search each array item
            for (var i = obj.length - 1; i >= 0; i--) {
                if (this._search(obj[i], search)) {
                    return true;
                }
             }
        } else if ($.isPlainObject(obj)) {
            //search each obj property
            for (var prop in obj) {
                if (this._search(obj[prop], search)) {
                    return true;
                }
            }
        } else {
            //plain value
            var value = obj.toString().toLowerCase();
            if (value.indexOf(search) !== -1) {
                return true;
            }
        }
        return false;
    };

    ListingView.prototype._getSearchText = function() {
        return this.$txtSearch.val().trim().toLowerCase();
    };

    ListingView.prototype.onClearSearchText = function () {
        this.$txtSearch.val('');
        this.onSearch();
    };

    ListingView.prototype.onSearchTextBlur = function() {
        //when keyboard closes, refresh search--iphone changes page height, which makes the iScroll shorter...
        this.onSearch();
    }

    return ListingView;
});
