/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview MainMenuView module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var $ = require('jquery');
    var Views = require('lib/Views');
    //require('jquery-ui');

    var PageScrollView = require('views/PageScrollView');

    var features = require('models/FeatureAdapter');

    var BaseView = require('views/BaseView');

    var PAGINATION_SELECTOR = 'js-pagination';
    var PAGE_INDICATOR = '<span class="pageIndicator"></span>';
    var PAGE_INDICATOR_CLASS = 'pageIndicator';
    var PAGE_INDICATOR_ACTIVE_CLASS = 'pageIndicator_isActive';

    var VIEWPORT_PADDING = 9;
    var BODY = document.body;

    var MainMenuView = function($element) {
        this.$element = $element;
        this.isEnabled = false;

        this.init();
    };


    /**
     * Added to make this class extend BaseView
     */
    MainMenuView.prototype = new BaseView();
    MainMenuView.prototype.constructor = MainMenuView;


    MainMenuView.prototype.init = function() {
        BaseView.prototype.init.call(this);

        /**
         * This property is used to help prevent infinite loops after adding authentication to main menu buttons
         * with submenus, submenu buttons, and to allow the reopening of the submenu upon returning to the main menu.
         *
         * A value of true means that the button was clicked by the user, if it has a submenu and a password, it should
         * be opened only after successful authentication, otherwise it should open normally.
         *
         * A value of false means that we are opening the submenu without user interaction (returning to the page after
         * clicking the back button)
         *
         * A value of null means that we have already opened the submenu for an action that was not user initiated.
         *
         * @type {boolean|null}
         * @property
         */
        this.isManualClick = false;

        /**
         * Whether or not the submenu is shown.
         *
         * @type {boolean}
         */
        this.isSubMenuShown = false;

        return this;
    };

    MainMenuView.prototype.setupHandlers = function() {
        BaseView.prototype.setupHandlers.call(this);

        this.onMainMenuButtonClickHandler =
            this.onMainMenuButtonClick.bind(this);

        this.onHideSubMenuHandler = this.onHideSubMenu.bind(this);

        this.subMenuOnRecieveDataCallbackHandler =
            this.subMenuOnRecieveDataCallback.bind(this);

        this.onScrollViewPageChangeHandler = $.proxy(this.onScrollViewPageChange, this);

        return this;
    };

    MainMenuView.prototype.createChildren = function () {
        BaseView.prototype.createChildren.call(this);

        this.$window = $(window);
        this.$headerContainer = this.$element.find('.header');
        this.$scrollPageView = this.$element.find('.js-scrollPageView');
        this.pageScrollView = new PageScrollView(this.$scrollPageView);

        this.$mainSlider = this.$element.find('.js-main-slider');
        this.$menuButtonRows = this.$element.find('.blocks');
        this.$menuButtons = this.$element.find('.js-menu-button');
        this.$subMenu = this.$element.find('.js-submenu-container');
        this.$pagination = this.$element.find('.js-pagination');
        this.$activePageIndicator = null;

        this.createSubmenuPagination();

        this.$currentSelectedButton = null;

        //change by Jeff & Nate to change header image
        $('.headerLogo').css("background-image", 'url("assets/media/images/header_' + SETTINGS.FACILITY_ID + '.png")');

        return this;
    };

    MainMenuView.prototype.createSubmenuPagination = function() {
        var numberOfPages = this.pageScrollView.getNumberOfPages();
        var $element;
        this.$pagination.empty();

        var i = 0;
        for (; i < numberOfPages; i++) {
            $element = $(PAGE_INDICATOR);

            if (i === this.pageScrollView.currentPageIndex) {
                $element.addClass(PAGE_INDICATOR_ACTIVE_CLASS);
                this.$activePageIndicator = $element;
            }

            this.$pagination.append($element);
        }
    };

    MainMenuView.prototype.removeChildren = function() {
        BaseView.prototype.removeChildren.call(this);

        this.$window = null;
        this.$headerContainer = null;

        this.$scrollPageView = null;
        this.pageScrollView.destroy();
        this.pageScrollView = null;

        this.$mainSlider = null;
        this.$menuButtonRows = null;
        this.$menuButtons = null;
        this.$subMenu = null;
        this.$pagination = null;
        this.$activePageIndicator = null;

        this.$currentSelectedButton = null;

        return this;
    };

    MainMenuView.prototype.layout = function() {
        BaseView.prototype.layout.call(this);

        return this;
    };

    MainMenuView.prototype.enable = function() {
        BaseView.prototype.enable.call(this);

        this.$menuButtons.on(
            features.CLICK, // features.TAP
            this.onMainMenuButtonClickHandler
        );

        this.$window
            .on('hideSubMenu', this.onHideSubMenuHandler);

        this.pageScrollView.on(PageScrollView.PAGE_CHANGE, this.onScrollViewPageChangeHandler);

        this.setMainSliderHeight();

        this.pageScrollView.gotoPage(SETTINGS.MAIN_MENU_GOTOPAGE, false);

        return this;
    };

    MainMenuView.prototype.disable = function() {
        BaseView.prototype.disable.call(this);

        // Set the current page
        SETTINGS.MAIN_MENU_GOTOPAGE = this.pageScrollView.getCurrentPageIndex();
        this.pageScrollView.gotoPage(SETTINGS.MAIN_MENU_GOTOPAGE, false);

        this.$menuButtons.off(
            features.CLICK, // features.TAP
            this.onMainMenuButtonClickHandler
        );

        this.$window
            .off('hideSubMenu', this.onHideSubMenuHandler);

        this.pageScrollView.off(PageScrollView.PAGE_CHANGE, this.onScrollViewPageChangeHandler);

        return this;
    };

    MainMenuView.prototype.destroy = function() {
        BaseView.prototype.destroy.call(this);

        return this;
    };

    MainMenuView.prototype.showSubMenu = function() {
        // Do nothing if button id is null (should never happen)
        if (this.$currentSelectedButton.data('id') == null) {
            return;
        }
        this.isSubMenuShown = true;

        Util.log('---------- showSubMenu');
        Util.log('button id: ' + this.$currentSelectedButton.data('id'));
        Util.log('button title: ' + this.$currentSelectedButton.data('title'));

        // This event is handled by the RouteHandler
        this.$window.trigger(
            'showPartialTemplate',
            [
                this.subMenuOnRecieveDataCallbackHandler,
                Views.SubMenuPartial,
                {
                    'b': this.$currentSelectedButton.data('id'),
                    'title': this.$currentSelectedButton.data('title'),
                    'sub': 'true'
                }
            ]
        );
    };

    MainMenuView.prototype.setMainSliderHeight = function() {
        if (BODY.offsetHeight <= 460) {
            $('.blocks_tall').addClass('blocks_tall_shortIphone');
            $('.blocks_pad').addClass('blocks_pad_shortIphone');
            $('.gridSubmenu').addClass('gridSubmenu_shortIphone');
        }

        var viewportHeight = BODY.offsetHeight -
            this.$headerContainer.get(0).offsetHeight -
            VIEWPORT_PADDING;

        this.$scrollPageView.height(viewportHeight);
        this.$mainSlider.height(viewportHeight);
    };

    MainMenuView.prototype.subMenuOnRecieveDataCallback = function() {
        Util.log('---------- subMenuOnRecieveDataCallback');
        // If submenu items exists, need the api will allow us to skip this
        if (this.$subMenu.find('.js-submenu-button').length < 1) {
            this.hideSubMenu();
            return;
        }

        if (this.$currentSelectedButton == null) {
            Util.log('Doing nothing, this.$currentSelectedButton == null');
            return;
        }

        // Show submenu
        var $buttonRow = this.$currentSelectedButton.closest('.blocks');
        var $movableContainer = $buttonRow.closest('.js-scrollPageView-movable');
        var animateRowOffset = -($buttonRow.outerHeight() * $buttonRow.data('row'));
        $movableContainer
            .stop()
            .animate({'top': animateRowOffset + 'px'});

        this.$subMenu.css('display', 'block').insertAfter($buttonRow);
        this.$currentSelectedButton.addClass('gridIcon_isExpanded');
        this.$menuButtonRows.removeClass('gridRow_isExpanded');
        $buttonRow.addClass('gridRow_isExpanded');
    };

    MainMenuView.prototype.hideSubMenu = function() {
        Util.log('---------- hideSubMenu');
        // Hide submenu
        this.$subMenu.css('display', 'none');
        this.$subMenu.html('');
        this.isSubMenuShown = false;

        // Reset menu buttons container/Remove all Arrows
        this.$menuButtons.removeClass('gridIcon_isExpanded');

        if (this.$currentSelectedButton == null) {
            return;
        }

        // Reset button row container
        var $buttonRow = this.$currentSelectedButton.closest('.blocks');
        var $movableContainer = $buttonRow.closest('.js-scrollPageView-movable');
        $movableContainer
            .stop()
            .animate({'top': '0px'});

        $buttonRow.removeClass('gridRow_isExpanded');
        this.$currentSelectedButton = null;
    };

    //////////////////////////////////////////////////////////////////////////////////
    // EVENT HANDLERS
    //////////////////////////////////////////////////////////////////////////////////

    MainMenuView.prototype.onMainMenuButtonClick = function(event) {
        event.preventDefault();
        event.stopPropagation();
        Util.log('---------- onMainMenuButtonClick');
        this.isManualClick = true;
        this.activateMainMenuButton($(event.currentTarget));
        return false;
    };

    MainMenuView.prototype.onHideSubMenu = function(event) {
        this.hideSubMenu();
    };

    MainMenuView.prototype.onScrollViewPageChange = function(event, pageIndex) {
        this.$activePageIndicator.removeClass(PAGE_INDICATOR_ACTIVE_CLASS);
        this.$activePageIndicator = this.$pagination.children('.' + PAGE_INDICATOR_CLASS).eq(pageIndex);
        this.$activePageIndicator.addClass(PAGE_INDICATOR_ACTIVE_CLASS);
    };

    MainMenuView.prototype.showSubMenuById = function(id) {
        Util.log('---------- showSubMenuById');
        if (this.isManualClick === false) {
            this.activateMainMenuButton(this.$menuButtons.filter(function () {
                return $(this).data('id') === id;
            }));
        }
    };

    MainMenuView.prototype.activateMainMenuButton = function($button) {
        // Catch fringe case when sub menu partial has been destroyed but needs to be opened again
        // NEEDS REFACTORING
        Util.log('---------- activateMainMenuButton');
        if (this.$currentSelectedButton !== null &&
            this.$currentSelectedButton.data('feed-type') === Views.ShowSubMenu &&
            this.$subMenu !== null &&
            this.$subMenu.css('display') === 'none'
            ) {
            Util.log('Not Closing Button');
        }
        else {
            // Close button if it is already open (unless it is a button that opened a new window or a button that requires a password)
            if (this.$currentSelectedButton !== null &&
                this.$currentSelectedButton.data('id') === $button.data('id') &&
                !this.$currentSelectedButton.data('url') &&
                this.$currentSelectedButton.data('protected') !== 1 &&
                !this.isManualClick
                ) {
                Util.log('Do Nothing at main menu button id: ' + this.$currentSelectedButton.data('id') + ':' + this.$currentSelectedButton.data('title'));
                return;
            }
        }

        // Set selected button
        this.$currentSelectedButton = $button;

        if (this.isManualClick === false && $button.data('feed-type') === Views.ShowSubMenu && !this.isSubMenuShown) {
            this.isManualClick = null;
            this.showSubMenu();
            return;
        } else if (this.isManualClick === true && this.isSubMenuShown) {
            //this is needed (no time to refactor) to reset the lastPartialId on routehandler
            this.$window.trigger(
                'hideSubMenu'
            );
            return;
        }

        //I don't know why this is here...
        //this.hideSubMenu();

        // This event is handled by the RouteHandler
        this.$window.trigger(
            'onNavigationButtonClick',
            {
                $button: $button,
                MainMenuView: this
            }
        );

        return;
    };

    return MainMenuView;
});
