/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/* global define, device */
/**
 * @fileOverview OptionsPartialView module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var $ = require('jquery');

    var features = require('models/FeatureAdapter');

    var BaseView = require('views/BaseView');
    //var SmsPlugin = require('sms-plugin');
    //var SMSComposer = require('SMSComposer');
    var addCalendarEvent = require('lib/addCalendarEvent');


    var OptionsPartialView = function($element) {
        this.$element = $element;
        this.isEnabled = false;

        this.FACEBOOK_SHARE_URL = 'https://www.facebook.com/sharer/sharer.php';
        this.TWITTER_SHARE_URL = 'https://twitter.com/intent/tweet';

        this.init();
    };


    /**
     * Added to make this class extend BaseView
     */
    OptionsPartialView.prototype = new BaseView();
    OptionsPartialView.prototype.constructor = OptionsPartialView;


    OptionsPartialView.prototype.init = function() {
        BaseView.prototype.init.call(this);

        return this;
    };

    OptionsPartialView.prototype.setupHandlers = function() {
        BaseView.prototype.setupHandlers.call(this);

        this.onCloseClickHandler = this.onCloseClick.bind(this);
        this.onReminderClickHandler = this.onReminderClick.bind(this);
        this.onShareFacebookClickHandler = this.onShareFacebookClick.bind(this);
        this.onShareTwitterClickHandler = this.onShareTwitterClick.bind(this);
        this.onShareEmailClickHandler = this.onShareEmailClick.bind(this);
        this.onShareSMSClickHandler = this.onShareSMSClick.bind(this);

        return this;
    };

    OptionsPartialView.prototype.createChildren = function() {
        BaseView.prototype.createChildren.call(this);

        this.$closeButton = this.$element.find('.js-options-close');
        this.$reminderButton = this.$element.find('.js-reminder');
        this.$shareFacebookButton = this.$element.find('.js-share-facebook');
        this.$shareTwitterButton = this.$element.find('.js-share-twitter');
        this.$shareEmailButton = this.$element.find('.js-share-email');
        this.$shareSMSButton = this.$element.find('.js-share-sms');

        return this;
    };

    OptionsPartialView.prototype.removeChildren = function() {
        BaseView.prototype.removeChildren.call(this);

        this.$closeButton = null;
        this.$reminderButton = null;
        this.$shareFacebookButton = null;
        this.$shareTwitterButton = null;
        this.$shareEmailButton = null;
        this.$shareSMSButton = null;

        return this;
    };

    OptionsPartialView.prototype.layout = function() {
        BaseView.prototype.layout.call(this);

        return this;
    };

    OptionsPartialView.prototype.enable = function() {
        BaseView.prototype.enable.call(this);

        this.$closeButton.on(
            features.TAP,
            this.onCloseClickHandler
        );
        this.$reminderButton.on(
            features.TAP,
            this.onReminderClickHandler
        );
        this.$shareFacebookButton.on(
            features.TAP,
            this.onShareFacebookClickHandler
        );
        this.$shareTwitterButton.on(
            features.TAP,
            this.onShareTwitterClickHandler
        );
        this.$shareEmailButton.on(
            features.TAP,
            this.onShareEmailClickHandler
        );
        this.$shareSMSButton.on(
            features.TAP,
            this.onShareSMSClickHandler
        );

        return this;
    };

    OptionsPartialView.prototype.disable = function() {
        BaseView.prototype.disable.call(this);

        this.hidePartial();

        this.$closeButton.off(
            features.TAP,
            this.onCloseClickHandler
        );
        this.$reminderButton.off(
            features.TAP,
            this.onReminderClickHandler
        );
        this.$shareFacebookButton.off(
            features.TAP,
            this.onShareFacebookClickHandler
        );
        this.$shareTwitterButton.off(
            features.TAP,
            this.onShareTwitterClickHandler
        );
        this.$shareEmailButton.off(
            features.TAP,
            this.onShareEmailClickHandler
        );
        this.$shareSMSButton.off(
            features.TAP,
            this.onShareSMSClickHandler
        );

        return this;
    };

    OptionsPartialView.prototype.destroy = function() {
        BaseView.prototype.destroy.call(this);

        return this;
    };

    OptionsPartialView.prototype.hidePartial = function() {
        // Hide submenu
        this.$element.css('display', 'none');
    };

    //////////////////////////////////////////////////////////////////////////////////
    // EVENT HANDLERS
    //////////////////////////////////////////////////////////////////////////////////

    OptionsPartialView.prototype.onReminderClick = function(event) {
        event.preventDefault();
        var $button = $(event.currentTarget);
        var successCallback = this.hidePartial.bind(this);
        var reminderInMinutes = $button.data('value') || '';
        var details = {};

        details.title = $button.data('detail-title') || '';
        details.location = $button.data('detail-location') || '';
        details.notes = '';
        details.start = $button.data('detail-start') || '';
        details.end = $button.data('detail-end') || '';

        addCalendarEvent(details, reminderInMinutes, successCallback);
    };

    OptionsPartialView.prototype.onReminderClickHandler = function() {

    };

    OptionsPartialView.prototype.onShareFacebookClick = function(event) {
        event.preventDefault();
        var $button = $(event.currentTarget);

        var queryObject = {
            'u': $button.data('share-link'),
            'text': $button.data('share-text')
        };
        Util.windowOpen(
            this.FACEBOOK_SHARE_URL + '?' +
            $.param(queryObject),
            '_blank',
            'location=no'
        );

        return;
    };

    OptionsPartialView.prototype.onShareTwitterClick = function(event) {
        event.preventDefault();
        var $button = $(event.currentTarget);

        var queryObject = {
            'url': $button.data('share-link'),
            'text': $button.data('share-text')
        };
        Util.windowOpen(
            this.TWITTER_SHARE_URL + '?' +
            $.param(queryObject),
            '_blank',
            'location=no'
        );

        return;
    };

    OptionsPartialView.prototype.onShareEmailClick = function (event) {
        event.preventDefault();
        var $button = $(event.currentTarget);

        var subject = 'Share';
        var body = '';

        if ($button.data('share-text') != null) {
            body = body + $button.data('share-text');
        }
        if ($button.data('share-link') != null) {
            body = body + ' ' + $button.data('share-link');
        }

        //https://github.com/EddyVerbruggen/SocialSharing-PhoneGap-Plugin#3-installation
        window.plugins.socialsharing.shareViaEmail(
          body,
          subject,
          null, // TO: must be null or an array
          null, // CC: must be null or an array
          null, // BCC: must be null or an array
          null, // FILES: can be null, a string, or an array
          function() {}, // called when sharing worked, but also when the user cancelled sharing via email (I've found no way to detect the difference)
          function (error) {
              console.log(error);
              //the plugin comes back with 'not available' when the service is not available
            var notAvailable = error === 'not available';
            if (notAvailable) {
                //simply open a mailto link
                var queryObject = {
                    'subject': subject,
                    'body': body
                };
                var queryString = $.param(queryObject);
                queryString = queryString.replace(/\+/g, '%20');
                Util.windowOpen('mailto:?' + queryString);
            }
          }
        );

        return;
    };

    OptionsPartialView.prototype.onShareSMSClick = function(event) {
        event.preventDefault();
        var $button = $(event.currentTarget);

        var recipient = '';
        var body = '';

        if ($button.data('share-text') != null) {
            body = body + $button.data('share-text');
        }
        if ($button.data('share-link') != null) {
            body = body + ' ' + $button.data('share-link');
        }

        //https://github.com/EddyVerbruggen/SocialSharing-PhoneGap-Plugin#3-installation
        window.plugins.socialsharing.shareViaSMS(body, recipient, function (msg) { console.log('ok: ' + msg); }, function (msg) { alert('error: ' + msg); });

        return;
    };

    OptionsPartialView.prototype.onCloseClick = function(event) {
        event.preventDefault();

        this.hidePartial();
    };

    return OptionsPartialView;
});
