/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

define(function(require, module, exports) {
    'use strict';

    var $ = require('jquery');
    var features = require('models/FeatureAdapter');
    var EventBus = require('EventBus');

    /**
     * ScrollPageView Viewport Selector
     * Used to wrap the inner pages and maintain the currently animated state
     *
     * @property VIEWPORT_SELECTOR
     * @static
     * @final
     * @type {string}
     */
    var VIEWPORT_SELECTOR = '.js-scrollPageView-viewport';

    /**
     * Selector for all ScrollPageView pages
     * Used to indicate the pages of the scroll page view
     *
     * @property PAGE_SELECTOR
     * @static
     * @final
     * @type {string}
     */
    var PAGE_SELECTOR = '.js-scrollPageView-page';

    /**
     * Active page class
     * Used to indicate the currently active page in the DOM
     *
     * @property ACTIVE_PAGE_CLASS
     * @static
     * @final
     * @type {string}
     */
    var ACTIVE_PAGE_CLASS = 'js-scrollPageView-page_isActive';

    /**
     * Viewport Ready Class
     * Used to apply the transition state to the viewport
     * Applied 1 frame after creation to allow for all components to be updated before animating
     *
     * @property VIEWPORT_SELECTOR
     * @static
     * @final
     * @type {string}
     */
    var READY_CLASS = 'scrollPageView-viewport_isReady';

    /**
     * No Animation Class
     * Used to apply modifications to the page view without animations
     *
     * @property NO_ANIMATION_CLASS
     * @static
     * @final
     * @type {string}
     */
    var NO_ANIMATION_CLASS = 'scrollPageView-viewport_shouldNotAnimate';

    /**
     * Scrolling X Threshold before the scroll page view registers something as a 'scroll'
     *
     * @property SCROLL_X_THRESHOLD
     * @static
     * @final
     * @type {number}
     */
    var SCROLL_X_THRESHOLD = 5;

    /**
     * Scrolling Y Threshold before the scroll page view registers something as a 'scroll'
     *
     * @property SCROLL_Y_THRESHOLD
     * @static
     * @final
     * @type {number}
     */
    var SCROLL_Y_THRESHOLD = 12;

    /**
     * X Percentage threshold before the scroll page view decides to move to the scrolled page
     *
     * @property NEXT_X_THRESHOLD_PERCENTAGE
     * @static
     * @final
     * @type {number}
     */
    var NEXT_X_THRESHOLD_PERCENTAGE = 0.27;

    /**
     * Pooled object cache for updating the transforms of the DOM
     *
     * @property _positionCache
     * @type {object}
     */
    var _positionCache = {};

    /**
     * Value to be used to fix the offset spacing issue on pages when slid
     * QUICK FIX
     *
     * @property FIX_PAGE_OFFSET_MULTIPLIER
     * @static
     * @type {number}
     */
    var FIX_PAGE_OFFSET_MULTIPLIER = 3;

    /**
     * Regex to parse out the x position of a css matrix 2d
     *
     * @property MATRIX_REGEX
     * @static
     * @final
     * @type {RegExp}
     */
    var MATRIX_REGEX = /matrix\(1, 0, 0, 1, (-?\d+|-?\d+\.\d+), 0\)/;

    /**
     * ScrollPageView Behavior
     * Expects a viewport, container, and pages
     * Uses a viewport and webkit transitions to animate a scroll view
     * Built to function on both device and desktop
     * If no element is provided, this will fail
     *
     * @class ScrollPageView
     * @constructor
     *
     * @param {jQuery} $element Element to use for the page view
     */
    var ScrollPageView = function($element) {
        if (typeof $element === 'undefined') {
            throw new TypeError('Element must be provided');
        }
        this.init($element);
    };

    ScrollPageView.prototype = new EventBus();
    ScrollPageView.prototype.constructor = ScrollPageView;

    /**
     * Initialization method
     * Describes all properties and the lifecycle of the scroll view's creation
     *
     * @method init
     * @param {jQuery} $element Element to use for the page view
     * @chainable
     */
    ScrollPageView.prototype.init = function($element) {
        EventBus.call(this);

        /**
         * Flag for whether the page view has enabled interaction
         *
         * @property isEnabled
         * @type {boolean}
         * @default false
         */
        this.isEnabled = false;

        /**
         * Element that the page view is contained from
         * Default to be selected by .js-scrollPageView
         *
         * @property $element
         * @type {jQuery}
         */
        this.$element = $element;

        /**
         * Flag for whether the scroll view is currently being interacted with
         *
         * @property isActive
         * @type {boolean}
         * @default false
         */
        this.isActive = false;

        /**
         * Used only when active
         * Mouse or touch's active x position
         *
         * @property tapX
         * @type {number}
         * @default 0
         */
        this.tapX = 0;

        /**
         * Used only when active
         * Mouse or touch's active y position
         *
         * @property tapY
         * @type {number}
         * @default 0
         */
        this.tapY = 0;

        /**
         * Flag for whether the scroll view is considered scrolling
         * Scroll is triggered when one of the above thresholds are hit
         *
         * @property isScrolling
         * @type {boolean}
         * @default 0
         */
        this.isScrolling = false;

        /**
         * Current Scroll Offset
         * Offset in pixels from where the scroll view started its activation
         * Used only when active
         *
         * @property scrollOffset
         * @type {number}
         * @default 0
         */
        this.scrollOffset = 0;

        /**
         * Current Page Index
         * The current page that is indexed
         *
         * @property currentPageIndex
         * @type {number}
         * @default 0
         */
        this.currentPageIndex = 0;

        /**
         * Starting scroll offset
         * Scroll offset that was identified when the scroll view started in pixels
         * Offset should only be present when the scroll view was animating when it was touched
         * Used only when active
         *
         * @property scrollOffset
         * @type {number}
         * @default 0
         */
        this.scrollStartOffset = 0;

        /**
         * Actual threshold in pixels for when the next page should be displayed
         *
         * @property nextThreshold
         * @type {number}
         * @default 0
         */
        this.nextThreshold = 0;

        /**
         * Pages that are currently managed by the view
         *
         * @property $pages
         * @type {jQuery}
         */
        this.$pages = null;

        /**
         * Viewport object
         *
         * @property $viewport
         * @type {jQuery}
         */
        this.$viewport = null;

        return this.setupHandlers()
                   .createChildren()
                   .layout()
                   .enable();
    };

    /**
     * Sets up all handler methods the page view uses
     * Should only be run once
     *
     * @method setupHandlers
     * @chainable
     */
    ScrollPageView.prototype.setupHandlers = function() {
        this.onTapStartHandler = $.proxy(this.onTapStart, this);
        this.onTapMoveHandler = $.proxy(this.onTapMove, this);
        this.onTapEndHandler = $.proxy(this.onTapEnd, this);

        return this;
    };

    /**
     * Creates all dom references and any content points necessary
     * Should only be run once
     *
     * @method createChildren
     * @chainable
     */
    ScrollPageView.prototype.createChildren = function() {
        // Create any other dependencies here
        this.$viewport = this.$element.find(VIEWPORT_SELECTOR);
        var $viewport = this.$viewport;

        //don't use viewport, as that may be hidden, and outerWidth() can't get width, if the element is hidden
        this.viewportWidth = $(window).outerWidth();
        this.nextThreshold = this.viewportWidth * NEXT_X_THRESHOLD_PERCENTAGE;

        this.$pages = this.$viewport.find(PAGE_SELECTOR);

        this.$currentPage = this.$pages.siblings('.' + ACTIVE_PAGE_CLASS);
        if (!this.$currentPage.length) {
            this.$currentPage = this.$pages.eq(0);
            this.$currentPage.addClass(ACTIVE_PAGE_CLASS);
        }

        this.currentPageIndex = this.$pages.index(this.$currentPage);
        if (this.currentPageIndex > 0) {
                this.updateScrollViewPosition();
            }

        // Apply the ready class on the next run loop to enable animations from here on out
        this.runOnNextEventLoop(function() {
            $viewport.addClass(READY_CLASS);
        });

        return this;
    };

    /**
     * Lays out any children
     * May be run any number of times
     *
     * @method layout
     * @chainable
     */
    ScrollPageView.prototype.layout = function() {
        // Insert any layout or measurement logic here
        this.updateScrollViewPosition();

        return this;
    };

    /**
     * Enables the ScrollPageView's mouse/touch start methods
     *
     * @method enable
     * @chainable
     */
    ScrollPageView.prototype.enable = function() {
        if (this.isEnabled) {
            return this;
        }

        this.isEnabled = true;

        // Setup any event handlers
        this.$element.on(features.TAP_START, this.onTapStartHandler);

        return this;
    };

    /**
     * Disables the ScrollPageView's mouse/touch start methods
     *
     * @method disable
     * @chainable
     */
    ScrollPageView.prototype.disable = function() {
        if (!this.isEnabled) {
            return this;
        }

        this.isEnabled = false;

        // Tear down any event handlers
        this.$element.off(features.TAP_START, this.onTapStartHandler);

        return this;
    };

    /**
     * Destroys and cleans up any properties
     *
     * @method destroy
     * @chainable
     */
    ScrollPageView.prototype.destroy = function() {
        this.disable();
        this.deactivate();
        this.finishScroll();

        var property;
        for (property in this) {
            if (this.hasOwnProperty(property)) {
                this[property] = null;
            }
        }

        return this;
    };

    /**
     * Runs the specified operation immediately on the next event loop
     *
     * @method runOnNextEventLoop
     * @property {function} operation
     * @chainable
     */
    ScrollPageView.prototype.runOnNextEventLoop = function(operation) {
        setTimeout(operation, 0);
    };

    /**
     * Activates the scroll page view
     * Used to turn on any listeners after the scroll page view has been tapped
     *
     * @method activate
     * @chainable
     */
    ScrollPageView.prototype.activate = function() {
        if (this.isActive) {
            return this;
        }

        this.isActive = true;
        this.$element.on(features.TAP_MOVE, this.onTapMoveHandler);
        this.$element.on(features.TAP_END, this.onTapEndHandler);
        this.$element.on(features.TAP_LEAVE, this.onTapEndHandler);
        if (features.TAP_CANCEL) {
            this.$element.on(features.TAP_CANCEL, this.onTapEndHandler);
        }

        this.$viewport.addClass(NO_ANIMATION_CLASS);

        return this;
    };

    /**
     * Deactivates the scroll page view
     * Used to turn off any listeners after the scroll page view has finished being tapped
     *
     * @method deactivate
     * @chainable
     */
    ScrollPageView.prototype.deactivate = function() {
        if (!this.isActive) {
            return this;
        }

        this.isActive = false;
        this.$element.off(features.TAP_MOVE, this.onTapMoveHandler);
        this.$element.off(features.TAP_END, this.onTapEndHandler);
        this.$element.off(features.TAP_LEAVE, this.onTapEndHandler);
        if (features.TAP_CANCEL) {
            this.$element.off(features.TAP_CANCEL, this.onTapEndHandler);
        }

        this.$viewport.removeClass(NO_ANIMATION_CLASS);

        return this;
    };

    /**
     * Begins the scroll transaction
     *
     * @method startScroll
     * @chainable
     */
    ScrollPageView.prototype.startScroll = function() {
        this.isScrolling = true;

        return this;
    };

    /**
     * Finishes the scroll transaction and unsets any internal properties
     *
     * @method finishScroll
     * @chainable
     */
    ScrollPageView.prototype.finishScroll = function() {
        this.scrollOffset = 0;
        this.scrollStartOffset = 0;

        this.isScrolling = false;

        return this;
    };

    /**
     * Updates the current scroll view viewport position based on the current page
     *
     * @method updateScrollViewPosition
     * @chainable
     */
    ScrollPageView.prototype.updateScrollViewPosition = function () {
        var matrix = 'translate(' + this.getXTargetOffset() + 'px, 0)';

        _positionCache.transform = _positionCache.WebkitTransform = matrix;
        this.$viewport.css(_positionCache);

        return this;
    };

    /**
     * Request for ScrollPageView to goto the previous page
     * Doesn't perform anything if its already at that page
     *
     * @method gotoPreviousPage
     * @param {boolean} isAnimated flag for whether it should animate
     * @chainable
     */
    ScrollPageView.prototype.gotoPreviousPage = function(isAnimated) {
        return this.gotoPage(this.currentPageIndex - 1, isAnimated);
    };

    /**
     * Request for ScrollPageView to goto the next page
     * Doesn't perform anything if its already at that page
     *
     * @method gotoNextPage
     * @param {boolean} isAnimated flag for whether it should animate
     * @chainable
     */
    ScrollPageView.prototype.gotoNextPage = function(isAnimated) {
        return this.gotoPage(this.currentPageIndex + 1, isAnimated);
    };

    /**
     * Request for ScrollPageView to goto a page
     * Will animate if requested
     * Clamps the index within the page view boundaries
     *
     * @method gotoPage
     * @param {number} pageIndex target page index to scroll to
     * @param {boolean} isAnimated flag for whether it should animate
     * @chainable
     */
    ScrollPageView.prototype.gotoPage = function (pageIndex, isAnimated) {
        isAnimated = isAnimated || false;

        if (pageIndex >= this.$pages.length) {
            pageIndex = this.$pages.length - 1;
        } else if (pageIndex < 0) {
            pageIndex = 0;
        }

        if (pageIndex === this.currentPageIndex) {
            return this;
        }

        this.trigger(ScrollPageView.PAGE_CHANGE, pageIndex);

        if (!isAnimated) {
            this.$element.hide();
            var $viewport = this.$viewport;
            this.$viewport.addClass(NO_ANIMATION_CLASS);
            this.runOnNextEventLoop(function() {
                $viewport.removeClass(NO_ANIMATION_CLASS);
            });
        }
        var $currentPage = this.$pages.eq(pageIndex);
        this.$currentPage.removeClass(ACTIVE_PAGE_CLASS);
        $currentPage.addClass(ACTIVE_PAGE_CLASS);
        this.$currentPage = $currentPage;
        this.currentPageIndex = pageIndex;
        this.updateScrollViewPosition();

        if (!isAnimated) {
            this.$element.show();
        }

        return this;
    };

    /**
     * Gets the current page index value
     *
     * @method getCurrentPageIndex
     * @return {number} The current page index
     */
    ScrollPageView.prototype.getCurrentPageIndex = function() {
        return this.currentPageIndex;
    };

    /**
     * Gathers the current number of pages within the scroll view
     *
     * @method getNumberOfPages
     * @return {number} Number of pages in the page scroll view
     */
    ScrollPageView.prototype.getNumberOfPages = function() {
        return this.$pages.length;
    };

    /**
     * Calculates the X offset of the currently selected page
     *
     * @method getCurrentPageOffset
     * @return {number} offset
     */
    ScrollPageView.prototype.getCurrentPageOffset = function() {
        // This was removed to fix an offset issue.  Need to look further into this
        // return -this.viewportWidth * this.currentPageIndex;

        //grab fresh width in case orientation has changed or window size has changed: TODO: consider updating on orientation change only instead
        this.viewportWidth = $(window).outerWidth(); 

        return (-this.viewportWidth * this.currentPageIndex) -
            (FIX_PAGE_OFFSET_MULTIPLIER * this.currentPageIndex);
    };

    /**
     * Calculates the X offset of the currently selected page with current interaction offset
     *
     * @method getXTargetOffset
     * @return {number} offset
     */
    ScrollPageView.prototype.getXTargetOffset = function() {
        return this.getCurrentPageOffset() + this.scrollOffset;
    };

    /**
     * Retrieves the immediate calculated position relative to where it should be based on the current page
     *
     * @method getXOffsetFromCurrentPage
     * @return {number} offset
     */
    ScrollPageView.prototype.getXOffsetFromCurrentPage = function() {
        var targetPosition = this.getCurrentPageOffset();
        var currentMatrix = this.$viewport.css('WebkitTransform') || this.$viewport.css('Transform');
        var currentPosition = parseFloat(currentMatrix.match(MATRIX_REGEX)[1]);

        return targetPosition - currentPosition;
    };

    /**
     * onTapStart
     * Activates the scroll view and tracks the interaction
     *
     * @method onTapStart
     * @param {jQuery.Event} event
     */
    ScrollPageView.prototype.onTapStart = function(event) {
        if (this.isActive) {
            return;
        }

        this.scrollStartOffset = this.getXOffsetFromCurrentPage();

        if (features.isMobile) {
            var touch = event.originalEvent.touches[0];
            this.tapX = touch.clientX;
            this.tapY = touch.clientY;
        } else {

            this.tapX = event.clientX;
            this.tapY = event.clientY;
        }

        this.activate();

        this.scrollOffset = -this.scrollStartOffset;
        this.updateScrollViewPosition();
    };

    /**
     * onTapMove
     * Determines and triggers when a scroll has started
     *
     * @method onTapMove
     * @param {jQuery.Event} event
     */
    ScrollPageView.prototype.onTapMove = function(event) {
        if (!this.isActive) {
            return;
        }

        var deltaX;
        var deltaY;

        if (features.isMobile) {
            var touch = event.originalEvent.changedTouches[0];
            deltaX = touch.clientX - this.tapX;
            deltaY = touch.clientY - this.tapY;
        } else {
            deltaX = event.clientX - this.tapX;
            deltaY = event.clientY - this.tapY;
        }

        if (Math.abs(deltaX) > SCROLL_X_THRESHOLD || Math.abs(deltaY) > SCROLL_Y_THRESHOLD) {
            this.startScroll();
        }

        if (!this.isScrolling) {
            return;
        }

        event.preventDefault();
        event.stopPropagation();
        this.scrollOffset = deltaX - this.scrollStartOffset;
        this.updateScrollViewPosition();
    };

    /**
     * onTapEnd
     * Updates the page scroll view with the new page if one is necessary
     *
     * @method onTapEnd
     * @param {jQuery.Event} event
     */
    ScrollPageView.prototype.onTapEnd = function(event) {
        this.deactivate();

        if (!this.isScrolling) {
            this.finishScroll();
            this.updateScrollViewPosition();
            return;
        }

        event.preventDefault();
        event.stopPropagation();

        var deltaX;

        if (features.isMobile) {
            var touch = event.originalEvent.changedTouches[0];
            deltaX = touch.clientX - this.tapX - this.scrollStartOffset;
        } else {
            deltaX = event.clientX - this.tapX - this.scrollStartOffset;
        }

        this.finishScroll();
        if (Math.abs(deltaX) >= this.nextThreshold) {
            if (deltaX > 0) {
                this.gotoPreviousPage();
            } else {
                this.gotoNextPage();
            }
        }

        this.updateScrollViewPosition();
    };

    /**
     * Page Change Event
     * Used to trigger to other objects that the scroll view page has changed
     * Provides the event name and index of the new page
     *
     * @property PAGE_CHANGE
     * @static
     * @final
     * @type {string}
     */
    ScrollPageView.PAGE_CHANGE = 'pagechange';

    return ScrollPageView;
});
