/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview SettingsView module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var $ = require('jquery');
    //require('jquery-ui');

    var features = require('models/FeatureAdapter');
    var NotificationTags = require('lib/NotificationTags');

    var BaseView = require('views/BaseView');

    /**
     * A detail page view script. Handles button functionality.
     *
     * @name SettingsView
     * @class SettingsView A detail page view script. Handles button functionality.
     * @constructor
     * @param {jQuery} $element A reference to the containing DOM element
     */
    var SettingsView = function($element) {
        /**
         * A reference to the containing DOM element
         *
         * @default null
         * @name $element
         * @type {jQuery}
         */
        this.$element = $element;

        /**
         * Tracks whether component is enabled.
         *
         * @default false
         * @name isEnabled
         * @type {bool}
         */
        this.isEnabled = false;

        this.init();
    };


    /**
     * Added to make this class extend BaseView
     */
    SettingsView.prototype = new BaseView();
    SettingsView.prototype.constructor = SettingsView;


    /**
     * Initializes the UI Component View
     * Runs a single setupHandlers call, followed by createChildren and layout
     * Exits early if it is already initialized
     *
     * returns {SettingsView}
     */
    SettingsView.prototype.init = function() {
        BaseView.prototype.init.call(this);

        return this;
    };

    /**
     * Binds the scope of any handler functions
     * Should only be run on initialization of the view
     *
     * returns {SettingsView}
     */
    SettingsView.prototype.setupHandlers = function() {
        BaseView.prototype.setupHandlers.call(this);

        this.onTogglePushButtonChangeHandler =
            this.onTogglePushButtonChange.bind(this);
        this.onTogglableElementChangeHandler =
            this.onTogglableElementChange.bind(this);
        this.onEnableAllClickHandler = this.onEnableAllClick.bind(this);
        this.onDisableAllClickHandler = this.onDisableAllClick.bind(this);

        return this;
    };

    /**
     * Create any child objects or references to DOM elements
     * Should only be run on initialization of the view
     *
     * @returns {SettingsView}
     */
    SettingsView.prototype.createChildren = function() {
        BaseView.prototype.createChildren.call(this);

        this.$togglePushButton = this.$element.find('.js-toggle-push');
        this.$togglableElements = this.$element.find('.js-togglable-elements');
        this.$enableAll = this.$element.find('.js-enable-all');
        this.$disableAll = this.$element.find('.js-disable-all');

        return this;
    };

    /**
     * Remove any child objects or references to DOM elements
     *
     * @returns {SettingsView}
     */
    SettingsView.prototype.removeChildren = function() {
        BaseView.prototype.removeChildren.call(this);

        this.$togglePushButton = null;
        this.$togglableElements = null;
        this.$enableAll = null;
        this.$disableAll = null;

        return this;
    };

    /**
     * Performs measurements and applys any positioning style logic
     * Should be run anytime the parent layout changes
     *
     * @returns {SettingsView}
     */
    SettingsView.prototype.layout = function() {
        BaseView.prototype.layout.call(this);

        return this;
    };

    /**
     * Enables the component
     * Performs any event binding to handlers
     * Exits early if it is already enabled
     *
     * @returns {SettingsView}
     */
    SettingsView.prototype.enable = function() {
        BaseView.prototype.enable.call(this);

        this.$togglePushButton
            .on('change', this.onTogglePushButtonChangeHandler);

        this.$togglableElements
            .on('change', this.onTogglableElementChangeHandler);

        this.$enableAll
            .on(features.TAP, this.onEnableAllClickHandler);

        this.$disableAll
            .on(features.TAP, this.onDisableAllClickHandler);

        return this;
    };

    /**
     * Disables the component
     * Tears down any event binding to handlers
     * Exits early if it is already disabled
     *
     * @returns {SettingsView}
     */
    SettingsView.prototype.disable = function() {
        BaseView.prototype.disable.call(this);

        this.$togglePushButton
            .off('change', this.onTogglePushButtonChangeHandler);

        this.$togglableElements
            .off('change', this.onTogglableElementChangeHandler);

        this.$enableAll
            .off(features.TAP, this.onEnableAllClickHandler);

        this.$disableAll
            .off(features.TAP, this.onDisableAllClickHandler);

        return this;
    };

    /**
     * Destroys the component
     * Tears down any events, handlers, elements
     * Should be called when the object should be left unused
     *
     * @returns {SettingsView}
     */
    SettingsView.prototype.destroy = function() {
        BaseView.prototype.destroy.call(this);

        return this;
    };


    //////////////////////////////////////////////////////////////////////////////////
    // EVENT HANDLERS
    //////////////////////////////////////////////////////////////////////////////////

    /**
     * onTogglePushButtonChange handler
     * Handles the change event of the toggle push input
     *
     * @param {Event} e JavaScript event object
     */
    SettingsView.prototype.onTogglePushButtonChange = function(event) {
        var $button = $(event.currentTarget);
        var value = 0;
        if ($button.prop('checked')) {
            value = 1;
        }

        NotificationTags.setIsPushEnabled(value);
    };

    /**
     * onTogglableElementChange handler
     * Handles the change event of the togglable inputs
     *
     * @param {Event} e JavaScript event object
     */
    SettingsView.prototype.onTogglableElementChange = function(event) {
        var $button = $(event.currentTarget);
        var value = 0;
        if ($button.prop('checked')) {
            value = 1;
        }

        NotificationTags.toggleTag($button.attr('id'), value);
    };

    /**
     * onEnableAllClick handler
     * Handles the click event of the enable all button
     *
     * @param {Event} e JavaScript event object
     */
    SettingsView.prototype.onEnableAllClick = function(event) {
        NotificationTags.toggleAllTags(1);
        this.$togglableElements.prop("checked", true);
    };

    /**
     * onDisableAllClick handler
     * Handles the click event of the disable all button
     *
     * @param {Event} e JavaScript event object
     */
    SettingsView.prototype.onDisableAllClick = function(event) {
        NotificationTags.toggleAllTags(0);
        this.$togglableElements.prop("checked", false);
    };


    return SettingsView;
});
