/*!
 * THIS FILE HAS BEEN GENERATED BY AN AUTOMATED TOOL.
 * DO NOT MODIFY DIRECTLY. INSTEAD, MODIFY THE APPROPRIATE SOURCE CODE.
 *
 * test v1.0.0 (dev)
 * Example project for Client.
 * Build Date: 2016-04-05
 */

/**
 * @fileOverview SubMenuPartialView module definition
 */

define(function(require) {
    'use strict';

    var Util = require('lib/Util');
    var $ = require('jquery');
    var Views = require('lib/Views');
    var features = require('models/FeatureAdapter');
    //require('jquery-ui');

    var BaseView = require('views/BaseView');

    var SubMenuPartialView = function($element) {
        this.$element = $element;
        this.isEnabled = false;

        this.init();
    };


    /**
     * Added to make this class extend BaseView
     */
    SubMenuPartialView.prototype = new BaseView();
    SubMenuPartialView.prototype.constructor = SubMenuPartialView;


    SubMenuPartialView.prototype.init = function() {
        BaseView.prototype.init.call(this);

        return this;
    };

    SubMenuPartialView.prototype.setupHandlers = function() {
        BaseView.prototype.setupHandlers.call(this);

        this.onSubMenuButtonClickHandler =
            this.onSubMenuButtonClick.bind(this);

        this.onSubMenuCloseClickHandler =
            this.onSubMenuCloseClick.bind(this);

        return this;
    };

    SubMenuPartialView.prototype.createChildren = function() {
        BaseView.prototype.createChildren.call(this);

        this.$window = $(window);

        this.$mainMenu = $('#' + Views.MainMenu);
        this.$menuButtons = this.$mainMenu.find('.js-menu-button');
        this.$subMenu = this.$mainMenu.find('.js-submenu-container');
        this.$subMenuButtons = this.$element.find('.js-submenu-button');
        this.$subMenuCloseButton = this.$element.find('.js-submenu-close');

        return this;
    };

    SubMenuPartialView.prototype.removeChildren = function() {
        BaseView.prototype.removeChildren.call(this);

        this.$window = null;

        this.$mainMenu = null;
        this.$menuButtons = null;
        this.$subMenu = null;
        this.$subMenuButtons = null;
        this.$subMenuCloseButton = null;

        return this;
    };

    SubMenuPartialView.prototype.layout = function() {
        BaseView.prototype.layout.call(this);

        return this;
    };

    SubMenuPartialView.prototype.enable = function() {
        BaseView.prototype.enable.call(this);

        this.$subMenuButtons.on(
            features.CLICK,
            this.onSubMenuButtonClickHandler
        );
        this.$subMenuCloseButton.on(
            features.CLICK,
            this.onSubMenuCloseClickHandler
        );

        return this;
    };

    SubMenuPartialView.prototype.disable = function() {
        BaseView.prototype.disable.call(this);

        this.hideSubMenu();

        this.$subMenuButtons.off(
            features.CLICK,
            this.onSubMenuButtonClickHandler
        );
        this.$subMenuCloseButton.off(
            features.CLICK,
            this.onSubMenuCloseClickHandler
        );

        return this;
    };

    SubMenuPartialView.prototype.destroy = function() {
        BaseView.prototype.destroy.call(this);

        return this;
    };

    SubMenuPartialView.prototype.hideSubMenu = function() {
        // Hide submenu
        this.$subMenu.css('display', 'none');
        // Reset menu buttons container
        this.$menuButtons.removeClass('gridIcon_isExpanded');

        // Reset button row container
        var $buttonRow = this.$element.prev();
        $buttonRow.removeClass('gridRow_isExpanded');
    };

    //////////////////////////////////////////////////////////////////////////////////
    // EVENT HANDLERS
    //////////////////////////////////////////////////////////////////////////////////

    SubMenuPartialView.prototype.onSubMenuButtonClick = function(event) {
        event.preventDefault();

        var $button = $(event.currentTarget);

        // This event is handled by the RouteHandler
        this.$window.trigger(
            'onNavigationButtonClick',
            {
                $button: $button
            }
        );

        return;
    };

    SubMenuPartialView.prototype.onSubMenuCloseClick = function(event) {
        event.preventDefault();

        this.$window.trigger(
            'hideSubMenu'
        );
    };

    return SubMenuPartialView;
});
